//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <vcl\Clipbrd.hpp>
USEFORM("Main.cpp", MainForm);
USEFORM("Options.cpp", OptionsForm);
USEFORM("About.cpp", AboutForm);
//---------------------------------------------------------------------------
bool IsFirstInstance();

//---------------------------------------------------------------------------
// Unicode version, but Tclipboard is not Unicode compliant ...
//WINAPI wWinMain(HINSTANCE, HINSTANCE, LPWSTR lpCmdLine, int)
WINAPI WinMain(HINSTANCE, HINSTANCE, LPSTR lpCmdLine, int)
{
	if (!IsFirstInstance())		// If not 1st instance
    {
		char szBuf[255];

		// I put in the clipboard the 2nd instance CmdLine
		strcpy(szBuf, "AVIcodec: ");
        strcat(szBuf, lpCmdLine);
//		MessageBox(NULL, szBuf, "Debug", 0);        
		TClipboard	*clip=Clipboard();
       	clip->SetTextBuf(szBuf);
        clip->Close();

    	return 1;
    }

	try
	{
		Application->Initialize();
		Application->Title = "AVIcodec";
		Application->CreateForm(__classid(TMainForm), &MainForm);
		Application->CreateForm(__classid(TOptionsForm), &OptionsForm);
		Application->CreateForm(__classid(TAboutForm), &AboutForm);
		Application->Run();
	}
	catch (Exception &exception)
	{
		Application->ShowException(&exception);
	}
	return 0;
}
//---------------------------------------------------------------------------

// Verifies if first instance

bool IsFirstInstance()
{
	HANDLE hMapping;
    hMapping = CreateFileMapping( (HANDLE) 0xffffffff, NULL,
                 PAGE_READONLY, 0, 32, "AVIcodec" );
	if (!hMapping)// Some other error; handle error.
	{
//		MessageBox (NULL, "Error creating mapping", "AVIcodec", MB_OK);
//		ExitProcess(1);
		return true;		// I continue the execution because may fail under old systems ?
	}
	else if (GetLastError() == ERROR_ALREADY_EXISTS)
	{
		// the app is already running.
//		MessageBox( NULL, "Application is already running.", "AVIcodec", MB_OK );

		// Bring it to front
		HWND hwndPrev = FindWindow(NULL, "AVIcodec");

		// If so, does it have any popups?
		HWND hwndChild = GetLastActivePopup(hwndPrev);

		// If iconic, restore the main window
		if (IsIconic(hwndPrev))
			ShowWindow(hwndPrev, SW_RESTORE);

		// Bring the main window or its popup to the foreground
		SetForegroundWindow(hwndChild);

		// and you are done activating the other application
		return false;
    }
	return true;
}


