//---------------------------------------------------------------------------
// AVI format : studied by myself
// REAL, OGG format : big help to start understanding the format from
// Quovadis (quovadis@nbsi.de) the author of NBS Catalogue (http://nbsi.de).
//---------------------------------------------------------------------------
#include <vcl.h>						// ShowMesssage
#pragma hdrstop
#pragma warn -pin						// Suppr warning "Init is partially bracketed"

#include "dshow.h"						// DirectShow
#include <aviriff.h>					// AVISTREAMHEADER, replace old vfw.h
#include <dvdmedia.h>					// VIDEOINFOHEADER2
#include <io.h>							// filelength
#include <stdio.h>						// fopen
//#include <vfw.h>						// AVIFileInit // listtypeAVIMOVIE
#include "qedit.h"						// IMediaDet

#include "Main.h"						// MainForm
#include "fileinfo.h"
#include "multinfo.h"
#include "mpeginfo.h"

//#define DEBUG	1

extern struct FileInfo *pai;

char	szErr[100];

// Open an AVI file and retrieve main information
// -----------------------------------------------------------

int GetAVIinfo (wchar_t * wszFile)
{
	char	cType[5];
	int		sn,							// Stream Number
			sh2wfx,
			as;
	LONG	size;
	RIFFLIST	riffC;					// FOURCC fcc; DWORD cb; (aviriff.h)
	RIFFLIST	riffL;					// FOURCC fcc; DWORD cb; FOURCC fccListType;
	FOURCC fccListType;
	AVISTREAMHEADER	sh[MAXSTREAMS],		// StreamHeader
				*psh;
	BITMAPINFOHEADER	bih;
	WAVEFORMATEX	wfx[MAXSTREAMS];	// Wave information
	char	szInfo[100];
	FILE	*fh;
	char	szBuf[MAXHEAD+1];			// Multipurpose buffer
	int		len,						// lenght of bytes read
            pos;						// Current pos from beginning of file
	bool	bStop;
    DWORD	dwAFL[MAXAUDIOSTREAMS][3];					// Audio Frame Length (the 3 first)
    int		iAFL[3];

	// Zero init to ease the debugging
    for (int i=0 ; i<MAXSTREAMS ; i++)
    	memset (&sh[i], 0, sizeof (AVISTREAMHEADER));
    for (int i=0 ; i<MAXAUDIOSTREAMS ; i++)
    {
    	memset (&wfx[i], 0, sizeof (WAVEFORMATEX));
        memset (&dwAFL[i], 0, 3*sizeof(DWORD));
    }
    for (int i=0 ; i<3 ; i++)
    	iAFL[i] = 0;
	szInfo[0] = '\0';
	cType[4] = 0;

	// Header reading

	fh = _wfopen (wszFile, L"rb");	// Open file with Unicode filename
	if (fh == NULL)
	{	strcpy (szErr, szErrorString[7]);	return -1;	}

	len = fread (&riffL, 1, sizeof(RIFFLIST), fh);
	if (!len)
	{
    	fclose (fh);
    	strcpy (szErr, szErrorString[8]);
        return -2;
    }
	pos = len;

	// Header control

	pai->dwFileTheoSize = riffL.cb + 8;	// Total size
	if ((pai->dwFileTheoSize > pai->dwFileRealSize) &&
    	!((AnsiString)wszFile).Pos(".hdr") && 	// Not AVIcodec header file (small)
        !((AnsiString)wszFile).Pos(".head"))	// Old AVIcodec header extension
	{
		char	szMess[100];
		wsprintf (szMess, szErrorString[9], ((AnsiString)wszFile).c_str());
		if (!bOptions[OPT_Silent])
			ShowMessage (szMess);
	}

	if (riffL.fccListType != formtypeAVI) 	// "AVI "
	{	strcpy (szErr, szErrorString[10]); return -4;	}

	// RIFF analyse

	sn = 0;
    bStop = false;
    while (!bStop)
    {
		len = fread (&riffC, 1, sizeof(RIFFCHUNK), fh);
		if (!len)	break;				// End of RIFF file (or error ?)
		pos += len;

		if (riffC.cb%2 == 1)			// Solve wrong chunk size issue ...
            riffC.cb++;

		if (riffC.fcc == mmioFOURCC('L', 'I', 'S', 'T'))	// LIST : read ListType but not using it
        {
			len = fread (&fccListType, 1, sizeof(FOURCC), fh);	// hdrl, strl, odml, INFO, movi
			if (!len)	break;			// Error
			pos += len;

			if (fccListType == mmioFOURCC('m', 'o', 'v', 'i'))
			    pai->dwFileHeadSize = pos-12;
        }
        else switch (riffC.fcc)
   	    {
		case ckidSTREAMHEADER:			// strh
			len = fread (&sh[sn].fccType, 1, riffC.cb, fh);
			if (!len)	break;			// Error
			pos += len;

			sn++;
			if (sn == MAXSTREAMS) 	bStop = true;	// For DIVX6 format ?
			break;
		case ckidSTREAMFORMAT:			// strf
			size = 0;
			if (sh[sn-1].fccType == streamtypeVIDEO)
			{
				size = sizeof (BITMAPINFOHEADER);
				len = fread (&bih, 1, size, fh);
				if (!len)	break;		// Error

				// Those information are more accurate than in StreamHeader
				sh[sn-1].rcFrame.right = bih.biWidth;
				sh[sn-1].rcFrame.bottom = bih.biHeight;
				if (bih.biCompression >= 0x20000000)	// it means it condains a more precise codec than found in strh (RLE = 0x1)
					sh[sn-1].fccHandler = bih.biCompression;
			}
			else if (sh[sn-1].fccType == streamtypeAUDIO)
			{
				size = sizeof (WAVEFORMATEX);
				as = pai->wAStreamsNb++;
				len = fread (&wfx[as], 1, size, fh); // WAVEFORMATEX
				if (!len)	break;		// Error
	            sh2wfx = sn-1 - as;		// Relative position between sh & wfx
			}
			if (fseek (fh, riffC.cb-size, SEEK_CUR))	break;	 	// Error
			pos += riffC.cb;
			break;

		// INFO LIST CHUNKS (from the Multimedia Programmer's Reference
		case RIFFINFO_IART:
		case RIFFINFO_ICRD:
		case RIFFINFO_IPRD:
		case RIFFINFO_ISBJ:
		case RIFFINFO_ISFT:
		case RIFFINFO_ISRC:
		case RIFFINFO_ISMP:
			len = fread (szBuf, 1, riffC.cb, fh);
			if (!len)	break;			// Error
			pos += len;

			if (strlen (szInfo) + len + 2 < 100)	// Max buffer size
            {
				strcat (szInfo, szBuf);
				strcat (szInfo, ", ");
            }
            break;

		case mmioFOURCC('0', '0', 'w', 'b'):	// 1st stream is audio
		case mmioFOURCC('0', '1', 'w', 'b'):	// 2nd stream is audio
		case mmioFOURCC('0', '2', 'w', 'b'):	// 3rd stream is audio
// This test is done to know if audio stream is CBR (constant bitrate) or VBR
			as = ((riffC.fcc>>8) & 0xFF) - '0';
			dwAFL[as][iAFL[as]++] = riffC.cb;
			if (iAFL[pai->wAStreamsNb] == 3)
				bStop = true;					// Stop after reading the third audio frame

		case mmioFOURCC('0', '0', 'd', 'b'):	// 1st stream is image (dv)
		case mmioFOURCC('0', '1', 'd', 'b'):	// 2nd stream is image (dv)

		case mmioFOURCC('0', '0', 'd', 'c'):	// 1st stream is video
		case mmioFOURCC('0', '1', 'd', 'c'):	// 2nd stream is video
			if (!pai->wAStreamsNb)
				bStop = true;					// Stop after 1st video stream if no audio stream

		case ckidAVIMAINHDR:			// avih
			// Do nothing because not interested
		default:						// JUNK, strn, ...
			if (fseek (fh, riffC.cb, SEEK_CUR))	break;				// Error
			pos += riffC.cb;
           	break;
        }
	}

	fclose (fh);
	if (!sn)
	{	strcpy (szErr, szErrorString[11]); return -5;	}

	// Store file information

	strcpy (pai->szFileInfo, szInfo);

	// Store video information

	psh = &sh[0];						// Pointer on stream info
	if ((psh->fccType != streamtypeVIDEO) &&
       	(psh->fccType != streamtypeAUDIO) &&
       	(psh->fccType != streamtypeDV))
		return -3;						// The 1st stream is not video

	for (int s=0 ; s<sn ; s++)
    {
	 psh = &sh[s];						// Pointer on stream info
     switch(psh->fccType)
     {
     case streamtypeVIDEO:
     case streamtypeDV:
		*(DWORD *)pai->szVC = psh->fccHandler;	// 1st FourCC
		pai->dwWidth = psh->rcFrame.right;
		pai->dwHeight = psh->rcFrame.bottom;
		pai->dwFramesNb = psh->dwLength;
		// We store 1000 * fps to keep a 3 digits precision
		pai->dwFps = 1000 * ((double)psh->dwRate) / ((double)psh->dwScale);
        break;

     case streamtypeAUDIO:
		int	n = s-sh2wfx;
		strcpy (pai->a[n].szABrType, (dwAFL[s][1]==dwAFL[s][2]) ? "CBR" : "VBR");	// If 2nd frame size = third
		pai->a[n].dwASec = psh->dwLength * psh->dwScale/psh->dwRate;
		pai->a[n].dwASnb = psh->dwLength;
		pai->a[n].wAC = wfx[n].wFormatTag;
		pai->a[n].dwAAvgBPS = wfx[n].nAvgBytesPerSec;
		pai->a[n].dwASps = wfx[n].nSamplesPerSec;
		pai->a[n].wAChannels = wfx[n].nChannels;
	 }
	}

	return 0;
}

// Open an MPG file and retrieve main information
// -----------------------------------------------------------

int GetMPGinfo (wchar_t *wszFile)
{
	return ParseMpeg2 (wszFile);
}

// Open an RM file and retrieve main information
// -----------------------------------------------------------

// Global properties

struct PROP
{
	WORD	wObjectVersion;
    DWORD	dwMaxBitrate;
    DWORD	dwAverageBitrate;			// Global=Audio+Video
    DWORD	dwMaxPacketSize;
    DWORD	dwAveragePacketSize;
    DWORD	dwNumberPackets;
    DWORD	dwDuration;
    DWORD	dwUnknown1;
    DWORD	dwUnknown2;
    DWORD	dwUnknown3;
    DWORD	dwUnknown4;
};

// General stream properties (MeDia PRoperties)

struct MDPR
{
	WORD	wObjectVersion;
    WORD	wStreamNumber;
    DWORD	dwMaxBitrate;
    DWORD	dwAverageBitrate;
    DWORD	dwMaxPacketSize;
    DWORD	dwAveragePacketSize;
	DWORD	dwStartTime;
    DWORD	dwPreroll;
    DWORD	dwDuration;
    BYTE	bStreamNameSize;
    char	szStreamName[0xC];		// 12 is a common value for bStreamNameSize
    BYTE	bMimeTypeSize;
    char	szMimeType[0x14];		// 20 is a common value for bMimeTypeSize
    DWORD	dwTypeSpecificLength;
    DWORD	dwChunkID;					// .ra0xFD for audio
    DWORD	dwVChunkID;					// VIDO for Video
};

// Specific audio stream properties

struct MDPR_Audio
{
//	DWORD	dwVersion;
	char	dwFourCC[4];
    DWORD	dwDummy1;
    WORD	wDummy2;
	DWORD	dwHeaderSize;
    WORD	wAudCodecInfo;		// Flavor ?
    DWORD	dwCodedFrameSize;
    DWORD	dwDummy3;
    DWORD	dwDummy4;
    DWORD	dwDummy5;
    WORD	wCodedFrameSize;	// ?
    DWORD	dwDummy6;
    DWORD	dwDummy7;
    WORD	wSampleRate;
    DWORD	dwDummy8;
    DWORD	dwDummy9;
    WORD	wChannels;
	char	dwGenr[4];			// always genr (?)
	char	dwAudCodec[4];		// cook, atrc, sipr
};

// Specific video stream properties

struct MDPR_Video
{
	char	dwFourCC[4];
	WORD	wWidth;
    WORD	wHeight;
	WORD	wDummy1;
	WORD	wDummy2;
	WORD	wDummy3;
    WORD	wFrameRate;
	WORD	wDummy4;
	DWORD	dwDummy5;
	DWORD	dwDummy6;
};

int GetRMinfo (wchar_t *wszFile)
{
	FILE	*fh;
	char	szBuf[MAXHEAD+1],
            szTemp[10];
    int		pos,
			as;
    DWORD	len,
    		code,
			dwAAvgBPS,
			dwASec,
            size;
    struct PROP	*pProp;
    struct MDPR	*pMdpr;
	struct MDPR_Audio	*pAudio;
	struct MDPR_Video	*pVideo;

	// Header reading

	fh = _wfopen (wszFile, L"rb");
	if (fh == NULL)
	{	strcpy (szErr, szErrorString[7]);	return -1;	}

	len = fread (szBuf, 1, MAXHEAD, fh);
	if (!len)
	{	strcpy (szErr, szErrorString[7]);	return -1;	}

	pai->dwFileHeadSize = 0x374;
	pos = 0;
    while (TRUE)
	{
		code = *(DWORD *)(szBuf+pos);
        if (code == mmioFOURCC('D','A','T','A'))
        	break;						// End of header

		size = INVDW(*(DWORD *)(szBuf+pos+4));

		switch (code)
        {
        case mmioFOURCC('.','R','M','F'):	// Real Media File
        case mmioFOURCC('C','O','N','T'):
            break;

        case mmioFOURCC('P','R','O','P'):
            pProp = (struct PROP *)(szBuf+pos+8);
            if (pProp->wObjectVersion)
            	break;
            pai->dwFileDuration = INVDW (pProp->dwDuration) /1000;
            break;

        case mmioFOURCC('M','D','P','R'):
            pMdpr = (struct MDPR *)(szBuf+pos+8);
            if (pMdpr->wObjectVersion)
            	break;

			if (!strncmp (pMdpr->szStreamName, "Audio", 5))// Audio Stream
//                   if (pMdpr->dwChunkID == mmioFOURCC('.','r','a',0xFD))	// Audio Stream
			{
				pai->wAStreamsNb++;
				as = pai->wAStreamsNb-1;
				dwAAvgBPS = INVDW (pMdpr->dwAverageBitrate)/8;
				dwASec = INVDW (pMdpr->dwDuration) /1000;

				if (as < MAXAUDIOSTREAMS)
                {
					pai->a[as].dwASec = dwASec;

					pAudio = (struct MDPR_Audio *)(szBuf+pos+8+sizeof (struct MDPR)+pMdpr->bStreamNameSize-0xC+pMdpr->bMimeTypeSize-0x14);
					if (pAudio->dwFourCC[3] == '5')
						strcpy (pai->a[as].szACname, "RealAudio 8");
					else
					{
						strncpy (pai->a[as].szACname, pAudio->dwFourCC, 4);
						pai->a[as].szACname[4] = 0;
					}
					strcat (pai->a[as].szACname, ",");
					strncat (pai->a[as].szACname, pAudio->dwAudCodec, 4);
					strcat (pai->a[as].szACname, "-");
					strcat (pai->a[as].szACname, itoa (INVW (pAudio->wAudCodecInfo), szTemp, 10));

					pai->a[as].wAChannels = INVW (pAudio->wChannels);
					pai->a[as].dwASps = INVW (pAudio->wSampleRate);
					pai->a[as].dwAAvgBPS = dwAAvgBPS;
	                pai->a[as].dwASnb = pai->a[as].dwASps * dwASec;
					pai->a[as].wACsupp = ftSUP;	// It is supported with RealPlayer
				}
            }
			else if (!strncmp (pMdpr->szStreamName, "Video", 5))// Video Stream
//                  else if (pMdpr->dwVChunkID == mmioFOURCC('V','I','D','O'))
			{
				pai->dwVAvgBPS = INVDW (pMdpr->dwAverageBitrate)/8;
				pai->dwVSec = INVDW (pMdpr->dwDuration) /1000;
				pai->dwVSize = pai->dwVAvgBPS * pai->dwVSec;

				pVideo = (struct MDPR_Video *)(szBuf+pos+8+sizeof (struct MDPR)+pMdpr->bStreamNameSize-0xC+pMdpr->bMimeTypeSize-0x14);
//				*(DWORD *)pai->szVC = pVideo->dwFourCC;
				strncpy (pai->szVC, pVideo->dwFourCC, 4);
				pai->szVC[4] = 0;
				pai->dwWidth = INVW (pVideo->wWidth);
				pai->dwHeight = INVW (pVideo->wHeight);
				pai->dwFps = 1000*INVW (pVideo->wFrameRate);
				pai->wVCsupp = ftSUP;	// It is supported with RealPlayer
            }
            break;
        }
        pos += size;
	}
	pai->dwFileHeadSize = pos;

	fclose (fh);
	return 0;
}

// Open an OGG file and retrieve main information
// -----------------------------------------------------------
// http://www.xiph.org/ogg/vorbis/doc/vorbis-spec-ref.html
// http://tobias.everwicked.com/packfmt.htm

struct OGG_Page_Header
{
	BYTE	bStreamStructureVersion;	// At this time always 0
	BYTE	bHeaderTypeFlag;			// b0set = continued packet, b1set = 1st page of logical bitstream, b2set = last page of logical bitstream
	DWORD	dwGranulePosition;			// Low DW (GranulePosition is __int64, but HighDW is = 0 at this time)
	DWORD	dwGranulePositionHi; 	 	// High DW
	DWORD	dwStreamSerialNumber;		// Link between logical & physical bitstream
	DWORD	dwPageSequenceNumber;
	DWORD	dwPageChecksum;
	BYTE	bPageSegments;
};

struct OGG_Common_Header
{
	BYTE	bPacketType;				// 1=ident, 3=comment, 5=setup, b0=0->audio
	char	cName[6];					// vorbis / video / Direct
};

struct OGG_Vorbis
{
	DWORD	dwVorbisVersion;
	BYTE	bAudioChannels;
	DWORD	dwAudioSampleRate;			// Sps
	DWORD	dwBitrateMaximum;			// bps
	DWORD	dwBitrateNominal;
	DWORD	dwBitrateLower;
    BYTE	bBlockSize;					// 2 exponent [4bits] | 2 exponent [4bits]
    BYTE	bStopFlag;					// Always 1
};

//// OggDS headers
// Header for the new header format
typedef struct OGG_Tobias_video
{
    DWORD	dwWidth;
    DWORD	dwHeight;
} OGG_Tobias_video;

// Taken from http://tobias.everwicked.com/packfmt.htm

typedef struct OGG_Tobias_audio
{
	WORD	wAChannels;
	WORD	wABlockalign;
	DWORD	dwAvgBPS;
} OGG_Tobias_audio;

struct OGG_Tobias						// Equivalent to struct stream_header
{
	char	cNameEnd[2];				// In Tobias def, cName is 8 characters long
	char	cSubtype[4];
    DWORD	dwSize;						// size of the structure
    DWORD	dwTimeUnit;
    DWORD	dwTimeUnitHi;
    DWORD	dwSamplesPerUnit;
    DWORD	dwSamplesPerUnitHi;
    DWORD	dwDefaultLen;				// in media time
    DWORD	dwBufferSize;
    WORD	wBitsPerSample;
    WORD	wPadding;
	union
	{
		OGG_Tobias_video	video;		// Video specific
		OGG_Tobias_audio	audio;		// Audio specific
	} sh;
};

void GetData (void *variable, int size, char *buffer)
{
	memcpy (variable, buffer, size);
}

void GetDataPos (void *variable, int size, char *buffer, int &position)
{
	memcpy (variable, buffer+position, size);
	position += size;
}
/// Some defines from OggDS
#define PACKET_TYPE_HEADER       0x01
#define PACKET_TYPE_COMMENT      0x03
#define PACKET_TYPE_BITS         0x07

#define MAXOGGSTREAMS	10				// Its more 255, but I simplify ...

int GetOGGinfo (wchar_t *wszFile)
{
	FILE	*fh;
	char	szBuf[MAXHEAD],
    		szSubtype[5],
            c,
            cStreamsType[MAXOGGSTREAMS];
    int		pos,
			as;
    DWORD	len,
    		time,
    		dwIdent,
            dwPageJump,
            dwPageSize;
	struct OGG_Page_Header	oph;
	struct OGG_Common_Header	och;
	struct OGG_Tobias	ot;
	struct OGG_Vorbis	oa;

	// Header reading

	fh = _wfopen (wszFile, L"rb");
	if (fh == NULL)
	{	strcpy (szErr, szErrorString[7]);	return -1;	}

	len = fread (szBuf, 1, MAXHEAD, fh);
	if (!len)
	{	strcpy (szErr, szErrorString[7]);	return -1;	}

	for (int i=0 ; i<MAXOGGSTREAMS ; i++)
    	cStreamsType[i] = ' ';

	pos = 0;
	GetDataPos (&dwIdent, sizeof (DWORD), szBuf, pos);
    while (dwIdent == mmioFOURCC('O','g','g','S'))
    {
		GetDataPos (&oph, sizeof (OGG_Page_Header), szBuf, pos);
        if (oph.bHeaderTypeFlag & 0x2)	// 1st page of logical bitstream
        {
            dwPageSize = 0;
            for (int i=0; i<oph.bPageSegments ; i++)
				dwPageSize += 0x000000FF & szBuf[pos++];
			dwPageJump = pos + dwPageSize;

			GetDataPos (&och, sizeof (OGG_Common_Header), szBuf, pos);
			if (och.bPacketType==PACKET_TYPE_HEADER)
			{
				if (!strncmp (och.cName, "video", 5))
				{
					GetDataPos (&ot, sizeof (OGG_Tobias), szBuf, pos);
                    strncpy(pai->szVC, ot.cSubtype, 4);
					pai->szVC[4] = '\0';

					pai->dwWidth = ot.sh.video.dwWidth;
					pai->dwHeight = ot.sh.video.dwHeight;
					pai->dwFps = ((double)10000000000) / ot.dwTimeUnit;

                    cStreamsType[oph.dwStreamSerialNumber] = 'v';
				}
				else if (!strncmp (och.cName, "audio", 5))
				{
					GetDataPos (&ot, sizeof (OGG_Tobias), szBuf, pos);
					pai->wAStreamsNb++;
					as = pai->wAStreamsNb-1;
                    cStreamsType[oph.dwStreamSerialNumber] = as;

					if (as < MAXAUDIOSTREAMS)
                    {
	                    strncpy(szSubtype, ot.cSubtype, 4);
						szSubtype[4] = '\0';
						pai->a[as].wAC = strtoul(szSubtype, NULL, 16);

						pai->a[as].wAChannels = ot.sh.audio.wAChannels;
						pai->a[as].dwASps = ot.dwSamplesPerUnit;
						pai->a[as].dwAAvgBPS = ot.sh.audio.dwAvgBPS * 8 / 8;
                    }
				}
            	else if (!strncmp (och.cName, "vorbis", 6))
				{
					GetDataPos (&oa, sizeof (OGG_Vorbis), szBuf, pos);
					as = pai->wAStreamsNb;
					pai->wAStreamsNb++;
					DWORD ssn = oph.dwStreamSerialNumber;
					if (ssn >= MAXOGGSTREAMS)	ssn = 0;	// For music files
                    cStreamsType[ssn] = as;

					pai->a[as].wAC = 0x674F;

					if (pai->wAStreamsNb <= MAXAUDIOSTREAMS)
                    {
						pai->a[as].wAChannels = oa.bAudioChannels;
						pai->a[as].dwASps = oa.dwAudioSampleRate;
                        if (oa.dwBitrateNominal != 0xFFFFFFFF)
							pai->a[as].dwAAvgBPS = oa.dwBitrateNominal / 8;	// Convert to Byte/s
                    }
				}
            	else if (!strncmp (och.cName, "Direct", 6))	// Direct Show
                {
					VIDEOINFOHEADER		pVIH;

					strncpy (pai->szVC, szBuf+pos+0x3D, 4);
					pai->szVC[4] = '\0';

					pos +=0x75;
					GetDataPos (&pVIH, sizeof (VIDEOINFOHEADER), szBuf, pos);
					pai->dwWidth = pVIH.bmiHeader.biWidth;
					pai->dwHeight = pVIH.bmiHeader.biHeight;
					pai->dwFps = ((double)10000000000) / pVIH.AvgTimePerFrame;
				}
            	else if (!strncmp (och.cName, "text", 4))
                {	}					// We don't do anything with comments
				else
                {
					if (!bOptions[OPT_Silent])
                    {
						char	szBuf[200];
						wsprintf (szBuf, szErrorString[12], och.cName, ((AnsiString)wszFile).c_str());
						ShowMessage (szBuf);
                    }
                }
            }
        }
        else break;						// End of header information ?
		pos = dwPageJump;				// pos should already be correct
		GetDataPos (&dwIdent, sizeof (DWORD), szBuf, pos);	// Should be OggS
    }
	pai->dwFileHeadSize = pos;

	// Now we read the end of file to read the last packet and calculate stream time

	fseek (fh, -MAXHEAD, SEEK_END);
	len = fread (szBuf, 1, MAXHEAD, fh);
	if (!len)
	{	strcpy (szErr, szErrorString[13]);	return -1;	}

	pos = MAXHEAD-20;
    do
    {
        while ((*(DWORD *)&szBuf[pos] != mmioFOURCC('O','g','g','S')) && pos)
        	pos--;
		if (!pos)						// No packet found, should not be possible
        	break;

		GetData (&oph, sizeof (OGG_Page_Header), szBuf+pos+4);

		DWORD ssn = oph.dwStreamSerialNumber;
		if (ssn >= MAXOGGSTREAMS)	ssn = 0;	// For music files
		c = cStreamsType[ssn];
        if (c == 'v')
				time = (1000L * oph.dwGranulePosition + pai->dwFps/2) / pai->dwFps;
        else if ((c == 0) || (c == 1) || (c == 2))
        	time = (oph.dwGranulePosition + pai->a[c].dwASps/2) / pai->a[c].dwASps;
		else
        {
			pos--;
			continue;					// (Audio) stream unknown
        }

		pai->dwFileDuration = pai->a[0].dwASec = pai->dwVSec = time;
        break;
	}	while (TRUE);

	fclose (fh);
	return 0;
}


// Parse object data

#define W_BIGENDIAN(a,b)	((a&0xFF) + ((b&0xFF)<<8))
#define DW_BIGENDIAN(a,b,c,d)	((a&0xFF) + ((b&0xFF)<<8) + ((c&0xFF)<<16) + ((d&0xFF)<<24))

int flv_parse_object (FILE *fh, bool isStrictArray, int depth)
{
	char	sName[128], sValue[128], *p;
    int		len;
	BYTE	bType;
	WORD	wLength=0;
	DWORD	dwValue;
	double	dVal;


	if (!isStrictArray)
    {
		len = fread (sValue, 1, sizeof(WORD), fh);
		wLength = W_BIGENDIAN(sValue[1],sValue[0]);
		len = fread (sName, 1, wLength, fh);
	}
	sName[wLength] = '\0';
    len = fread (&bType, 1, sizeof(BYTE), fh);
	if (!len)	return -2;

	switch (bType)
	{
    case 0:								// Double number
		len = fread (sValue, 1, sizeof(double), fh);
		if (!len)	return -2;
		p = (char *)&dVal;
		p[0]=sValue[7]; p[1]=sValue[6]; p[2]=sValue[5]; p[3]=sValue[4]; p[4]=sValue[3]; p[5]=sValue[2]; p[6]=sValue[1]; p[7]=sValue[0];
		dwValue = (DWORD)dVal;
		break;
	case 1:								// Boolean
		len = fread (sValue, 1, sizeof(BYTE), fh);
		if (!len)	return -2;
		dwValue = sValue[0];
		break;
	case 2:								// String, I skip it
		len = fread (sValue, 1, sizeof(WORD), fh);
		if (!len)	return -2;
		wLength = W_BIGENDIAN(sValue[1],sValue[0]);
		if (wLength < 127)
		{ 	fread (sValue, 1, wLength, fh); sValue[wLength] = '\0';	}
		else
        {	fseek (fh, wLength, SEEK_CUR); sValue[0] = '\0';	}
		break;
	case 3:
		while (1)
        {
			len = fread (&wLength, 1, sizeof(WORD), fh);
			if (!len)	return -2;
			fseek (fh, -sizeof(WORD), SEEK_CUR);
            if (!wLength)				// If End, 0x000009, so wLenght = 0
            	break;
	       	if (len = flv_parse_object (fh, false, depth+1) < 0)
    	       	return len;
		}
		len = fread (sValue, 1, 3, fh);	// UI24 ObjectEndMarker always = 9
		if (!len)	return -2;
        return 0;
	case 7:
		len = fread (sValue, 1, sizeof(WORD), fh);
		if (!len)	return -2;
		dwValue = W_BIGENDIAN(sValue[1],sValue[0]);
		break;
	case 8:						// ECMA Array
		DWORD	ECMAArrayLength;

		len = fread (sValue, 1, sizeof(DWORD), fh);
		if (!len)	return -2;
		ECMAArrayLength = DW_BIGENDIAN(sValue[3],sValue[2],sValue[1],sValue[0]);
		while (ECMAArrayLength-- > 0)	// Parse Array
        	if (len = flv_parse_object (fh, false, depth+1) < 0)
            	return len;
		len = fread (sValue, 1, 3, fh);	// UI24 ObjectEndMarker always = 9
		if (!len)	return -2;
		return 0;
	case 10:
		int	n;

		len = fread (sValue, 1, sizeof(DWORD), fh);
		if (!len)	return -2;
		n = DW_BIGENDIAN(sValue[3],sValue[2],sValue[1],sValue[0]);
		while (n-- > 0)
        	if (len = flv_parse_object (fh, true, depth+1) < 0)
            	return len;
		return 0;
	case 11:
		len = fread (sValue, 1, sizeof(double)+sizeof(WORD), fh);
		if (!len)	return -2;
		break;
	default:
		return -1;						// Error, rest of object will be skipped
	}

	if (isStrictArray)					// Just an array of data, nothing intersting for me
		return 1;

	if (!strcmp (sName, "duration") ||
		!strcmp (sName, "lasttimestamp"))
		pai->dwFileDuration = (DWORD)(dVal+0.5);
	else if (!strcmp (sName, "filesize") ||
//			!strcmp (sName, "datasize") ||	// Deactivated beacause wrong in certain file
			!strcmp (sName, "bytelength"))
		pai->dwFileTheoSize = dwValue;
	else if (!strcmp (sName, "videosize"))
		pai->dwVSize = dwValue;
	else if (!strcmp (sName, "width"))
		pai->dwWidth = dwValue;
	else if (!strcmp (sName, "height"))
		pai->dwHeight = dwValue;
	else if (!strcmp (sName, "videodatarate"))
		pai->dwVAvgBPS = dwValue*1000/8;
	else if (!strcmp (sName, "framerate"))
		pai->dwFps = (DWORD)(dVal*1000);
	else if (!strcmp (sName, "audiosize"))
		pai->dwATotSize = pai->a[0].dwASize = dwValue;
	else if (!strcmp (sName, "audiodatarate"))
		pai->a[0].dwAAvgBPS = dwValue*1000/8;
	else if (!strcmp (sName, "audiosamplerate"))
		pai->a[0].dwASps = dwValue;
	else if (!strcmp (sName, "creator"))
		strcpy (pai->szFileInfo, sValue);
	else if (!pai->szFileInfo[0] && !strcmp (sName, "metadatacreator"))
		strcpy (pai->szFileInfo, sValue);

	return 0;
}

// Open a FLV file and retrieve main information
// http://lists.mplayerhq.hu/pipermail/ffmpeg-devel/2006-November/049030.html
// http://www.buraks.com/flvmdi/
// -----------------------------------------------------------

int GetFLVinfo (wchar_t * wszFile)
{
	// Number are stored in Big Endian format, so I use char name[n] to read the date before computing the number
	struct
	{
		char	signature[3];			// "FLV"
        BYTE	version;				// 1 pour 1.0 et 1.1
		BYTE	flags;					// Audio (bit2=1), video (bit0=1), both = 5
        BYTE	offset[4];				// Header size = sizeof(flv_head)
    }	flv_head;
	struct
    {
		char	PreviousTagSize[4];		// Size of previous tag, including its header
		BYTE	TagType;				// 8: audio, 9: video, 18: script data
		BYTE	DataSize[3];  			// Length of the data in the Data field
		BYTE	Timestamp[3]; 			// Time in milliseconds at which the data in this tag applies. This
// is relative to the first tag in the FLV file, which always has a timestamp of 0.
		BYTE	TimestampExtended;		// Extension of the Timestamp field to form a UI32 value. This field represents the upper 8bits,
		BYTE	StreamID[3];			// Always 0
//        char *	Data;				// Body of the tag
	}	flv_tag;
	struct
    {
        unsigned int	SoundType:1;	// 0 = sndMono, 1 = sndStereo
        unsigned int	SoundSize:1;	// 0 = snd8Bit, 1 = snd16Bit
        unsigned int	SoundRate:2;	// 0=5.5 kHz, 1=11 kHz, 2=22 kHz, 3=44 kHz
		unsigned int	SoundFormat:4; 	// 0=Uncompressed, 1=ADPCM, 2=MP3, 5=Nellymoser 8kHz mono, 6=Nellymoser
//			char *	SoundData;
    }	flv_audio;
	struct
    {
        int	CodecID:4;					// 2: Sorenson H.263, 3: Screen video, 4: On2 VP6, 5: On2 VP6 with alpha channel, 6: Screen video version 2
		int	FrameType:4; 				// 1: keyframe, 2: inter frame, 3: disposable inter frame (H.263 only)
//			char *	VideoData;
    }	flv_video;
    bool	bAudio,						// Is Audio data encountered ?
	    	bVideo;						// Is Video data encountered ?
	int		i, len, pos;
    DWORD	dwOffset,
			dwDataSize,
			dwAudioSize,
            dwVideoSize,
			dwTimeStamp;
	FILE	*fh;
	char	szBuf[MAXHEAD+1];			// Multipurpose buffer

	bAudio = bVideo = false;
    dwAudioSize = dwVideoSize = 0;

	// Header reading

	fh = _wfopen (wszFile, L"rb");		// Open file with Unicode filename
	if (fh == NULL)
	{	strcpy (szErr, szErrorString[7]);	return -1;	}

	len = fread (&flv_head, 1, sizeof(flv_head), fh);
	dwOffset = DW_BIGENDIAN(flv_head.offset[3],flv_head.offset[2],flv_head.offset[1],flv_head.offset[0]);
	if (!len || dwOffset < 9)
	{
    	fclose (fh);
    	strcpy (szErr, szErrorString[8]);
        return -2;
    }
	if (flv_head.flags & 0x03 == 1)		// File is only containing audio
    	pai->bFileAudio = true;
	if (dwOffset > 9)			// Go to beginning of data
		fseek (fh, dwOffset, SEEK_SET);

	// Parse body, and search for "onMetaData"

    pos = sizeof(flv_head) - sizeof(flv_tag);
    dwDataSize = 0;
	while (1)
    {
	    pos += dwDataSize + sizeof(flv_tag);
		fseek (fh, pos, SEEK_SET);		// Go to the correct calculated place (to avoid junk problem)
		len = fread (&flv_tag, 1, sizeof(flv_tag), fh);

		dwDataSize = DW_BIGENDIAN(flv_tag.DataSize[2],flv_tag.DataSize[1],flv_tag.DataSize[0],0);
//		dwTimeStamp = DW_BIGENDIAN(flv_tag.Timestamp[2],flv_tag.Timestamp[1],flv_tag.Timestamp[0],flv_tag.TimestampExtended);
		if (!len || (dwDataSize < 11))
		{	fclose (fh); strcpy (szErr, szErrorString[2]); return -2;   	}

		switch (flv_tag.TagType)
        {
        case 8:							// Audio
			dwAudioSize += dwDataSize - sizeof(flv_audio);
			if (bAudio)
            	break;
			bAudio = true;

			len = fread (&flv_audio, 1, sizeof(flv_audio), fh);
			if (!len)
			{	fclose (fh); strcpy (szErr, szErrorString[2]); return -2;   	}

            pai->wAStreamsNb = 1;
			i = flv_audio.SoundFormat;
			// Uncompressed = PCM
			pai->a[0].wAC = (i==0 ? 0x0001 : i==1 ? 0x0002 : i==2 ? 0x0055 :
            	i==3 ? 0x0001 : i==5 ? 0xA005 : i==6 ? 0xA006 : 0x0000);
			i = flv_audio.SoundRate;
			pai->a[0].dwASps = (i==0 ? 5512 : i==1 ? 11025 : i==2 ? 22050 : 44100);
			pai->a[0].wAChannels = (flv_audio.SoundType==0 ? 1 : 2);

			// Skip audio data
			fseek (fh, dwDataSize-sizeof(flv_audio), SEEK_CUR);
			break;

        case 9:							// Video
			dwVideoSize += dwDataSize - sizeof(flv_video);
			if (bVideo)
            	break;
			bVideo = true;

			len = fread (&flv_video, 1, sizeof(flv_video), fh);
			if (!len)
			{	fclose (fh); strcpy (szErr, szErrorString[2]); return -2;   	}

			i = flv_video.CodecID;
			strcpy (pai->szVC, i==2 ? "H263" : i==3 ? "FSV1" : i==4 ? "VP60" :
            	i==5 ? "VP61" : i==6 ? "FSV2" : "");

			if (!pai->dwWidth)
				// Parse codec data, inspired from on http://cpan.uwinnipeg.ca/htdocs/FLV-Info/FLV/VideoTag.pm.html
            	switch (i)
    	        {
				case 2:						// Sorenson H263
            	{
					BitReader br(fh);
					int	res[7][2] = { { 0, 0 }, { 0, 0 }, { 352, 288 }, { 176, 144 }, { 128, 96 }, { 320, 240 }, { 160, 120 } };

					i = br.getBits(17);		// pictureStartCode (0000 0000 0000 0000 1)
					i = br.getBits(5);		// version (0 or 1)
					i = br.getBits(8);		// temporal reference
					i = br.getBits(3);		// picture size
	                if (i==0)
    	            {	pai->dwWidth = br.getBits(8);	pai->dwHeight = br.getBits(8);  }
        	        else if (i==1)
            	    {	pai->dwWidth = br.getBits(16);	pai->dwHeight = br.getBits(16);  }
                	else
	                {	pai->dwWidth = res[i][0];	pai->dwHeight = res[i][1];	}
    	        }    break;

				case 3:						// Screen Video
				case 6:
	            {	char	sValue[128];
    	        	int		len;

					len = fread (sValue, 1, sizeof(WORD), fh);
					pai->dwWidth = (W_BIGENDIAN(sValue[1],sValue[0]))& 0xFFF;
					len = fread (sValue, 1, sizeof(WORD), fh);
					pai->dwHeight = (W_BIGENDIAN(sValue[1],sValue[0]))& 0xFFF;;
				}	break;

				case 4:						// On2 VP6
				case 5:
                // VP61 not tested
                // http://wiki.multimedia.cx/index.php?title=On2_VP6
                // http://svn.mplayerhq.hu/ffmpeg/trunk/libavcodec/vp6.c?view=markup
                // http://cpan.uwinnipeg.ca/htdocs/FLV-Info/FLV/VideoTag.pm.html
            	{
					len = fread (szBuf+100, 1, (i==4 ? 1 : 4), fh);	// Jump offset (1 for VP60, 4 for VP61)

					BitReader br(fh);
                    int	fm,
                    	marker,
                        version2;

					fm = br.getBits(1);		// frame mode (0=intraframe, 1=keyframe)
					i = br.getBits(6);		// quantization parameter
                    marker = br.getBits(1);	// marker
					if (!fm)
                    {
	                    i = br.getBits(5);	// version
                        version2 = br.getBits(2);	// version2
	                    i = br.getBits(1);	// interlace
                        if ((marker==1) || (version2==0))
		                    i = br.getBits(16);	// secondary offset
					}
					pai->dwHeight = 16*br.getBits(8);
					pai->dwWidth = 16*br.getBits(8);
				}	break;

        	    default:
            	    break;
	            }

			// Skip video data
			fseek (fh, dwDataSize-sizeof(flv_video), SEEK_CUR);
			break;

        case 18:						// Script data
			len = fread (szBuf+100, 1, 1, fh);	// Always 2
			flv_parse_object (fh, false, 0);
			if (pai->dwWidth)
	            flv_head.flags |= 1;	// FLV contains video
// Desactivated because some files contains audio metadata but no audio stream .. (clip 1024.flv) 
//			if (pai->a[0].dwASps || pai->a[0].dwAAvgBPS)
//	            flv_head.flags |= 4;	// FLV contains audio
			break;

		default:						// Should not happen
			fseek (fh, dwDataSize, SEEK_CUR);	// Skip this tag
        }
        if (((flv_head.flags>>2) == bAudio) &&
        	((flv_head.flags & 1) == bVideo))
            break;						// Get out if both Audio & Video streams are found
    }

	// If some data are missing, try to get them by parsing the whole file
	if (!pai->dwFileDuration || !pai->dwFps || !pai->dwVSize || !pai->dwATotSize)
    {
		int	VideoFrames = 1;
		while (1)						// go to last tag to read last timestamp
    	{
	    	pos += dwDataSize + sizeof(flv_tag);
			len = fseek (fh, pos, SEEK_SET);		// Go to the correct calculated place (to avoid junk problem)
			if (len)
            	break;
			len = fread (&flv_tag, 1, sizeof(flv_tag), fh);
			if (!len)
            	break;
			dwDataSize = DW_BIGENDIAN(flv_tag.DataSize[2],flv_tag.DataSize[1],flv_tag.DataSize[0],0);
			dwTimeStamp = DW_BIGENDIAN(flv_tag.Timestamp[2],flv_tag.Timestamp[1],flv_tag.Timestamp[0],flv_tag.TimestampExtended);
            if (flv_tag.TagType == 8)	dwAudioSize += dwDataSize - sizeof(flv_audio);
            else if (flv_tag.TagType == 9)
            {
            	VideoFrames++;
				dwVideoSize += dwDataSize - sizeof(flv_video);
            }
		}
		pai->dwFileDuration = (dwTimeStamp+500)/1000;
		pai->dwFps = (VideoFrames+pai->dwFileDuration/2) / pai->dwFileDuration * 1000;
		pai->dwVSize = dwVideoSize;
		pai->dwATotSize = pai->a[0].dwASize = dwAudioSize;
    }

   	fclose (fh);
	return 0;
}

// MediaInfo analyze
// -----------------------------------------------------------

#define _UNICODE
#include "MediaInfoDLL.h"
#undef _UNICODE
using namespace MediaInfoLib;

int GetMediaInfo (wchar_t *wszFile)
{
    MediaInfo MI;
	AnsiString	as;

	MI.Open(wszFile);					//ouvre le fichier

	// File information

	as = MI.Get(Stream_General, 0, L"PlayTime", Info_Text, Info_Name).c_str();
	pai->dwFileDuration = atof(as.c_str())/1000;

	// Video information

//	strcpy (pai->szVC, ((AnsiString)MI.Get(Stream_Video, 0, L"Codec", Info_Text, Info_Name).c_str()).c_str());
	strcpy (pai->szVCname, ((AnsiString)MI.Get(Stream_Video, 0, L"Codec/String", Info_Text, Info_Name).c_str()).c_str());
	strcpy (pai->szVCurl, ((AnsiString)MI.Get(Stream_Video, 0, L"Codec/URL", Info_Text, Info_Name).c_str()).c_str());
	strcpy (pai->szAspRatio, ((AnsiString)MI.Get(Stream_Video, 0, L"AspectRatio/String", Info_Text, Info_Name).c_str()).c_str());
	pai->dwWidth = ((AnsiString)MI.Get(Stream_Video, 0, L"Width", Info_Text, Info_Name).c_str()).ToInt();
	pai->dwHeight = ((AnsiString)MI.Get(Stream_Video, 0, L"Height", Info_Text, Info_Name).c_str()).ToInt();

	pai->dwFramesNb = ((AnsiString)MI.Get(Stream_Video, 0, L"FrameCount", Info_Text, Info_Name).c_str()).ToInt();
	as = MI.Get(Stream_Video, 0, L"FrameRate", Info_Text, Info_Name).c_str();
	pai->dwFps = atof(as.c_str()) * 1000;
	as = MI.Get(Stream_Video, 0, L"PlayTime", Info_Text, Info_Name).c_str();
	pai->dwVSec = atof(as.c_str()) / 1000;
	as = ((AnsiString)MI.Get(Stream_Video, 0, L"Bitrate", Info_Text, Info_Name).c_str());
	if (as.data() != NULL)	pai->dwVAvgBPS = as.ToInt();

	// Audio information

	pai->wAStreamsNb = MI.Count_Get(Stream_Audio);
    for (int i=0 ; i<pai->wAStreamsNb ; i++)
    {
		strcpy (pai->a[i].szACname, ((AnsiString)MI.Get(Stream_Audio, i, L"Codec/String", Info_Text, Info_Name).c_str()).c_str());
		strcpy (pai->a[i].szACurl, ((AnsiString)MI.Get(Stream_Audio, i, L"Codec/Url", Info_Text, Info_Name).c_str()).c_str());
		strcpy (pai->a[i].szAInfo, ((AnsiString)MI.Get(Stream_Audio, i, L"Language/String", Info_Text, Info_Name).c_str()).c_str());
		pai->a[i].wAChannels = ((AnsiString)MI.Get(Stream_Audio, i, L"Channel(s)", Info_Text, Info_Name).c_str()).ToInt();
		as = ((AnsiString)MI.Get(Stream_Audio, i, L"BitRate_Mode", Info_Text, Info_Name).c_str());
		if (as.data() != NULL)	strcpy (pai->a[i].szABrType, as.c_str());
		pai->a[i].dwASnb = ((AnsiString)MI.Get(Stream_Audio, i, L"SamplingCount", Info_Text, Info_Name).c_str()).ToInt();
		as = ((AnsiString)MI.Get(Stream_Audio, i, L"SamplingRate", Info_Text, Info_Name).c_str());
		pai->a[i].dwASps = atof(as.c_str());
		as = ((AnsiString)MI.Get(Stream_Audio, i, L"Bitrate", Info_Text, Info_Name).c_str());
		if (as.data() != NULL)	pai->a[i].dwAAvgBPS = as.ToInt();
		as = MI.Get(Stream_Audio, i, L"PlayTime", Info_Text, Info_Name).c_str();
		pai->a[i].dwASec = atof(as.c_str()) / 1000;
    }

    MI.Close();
	return 0;
}

// Test if readable by DirectShow
// In detailled mode, some info on the filetype is searched
// -----------------------------------------------------------

#define MAXFILTERS	10
#define MAXPINS		4

int DSHOWtest (wchar_t *wszFile, BOOL bDetailled)
{
	HRESULT hr;

	// Create the Filter Graph Manager.
	IGraphBuilder *pGraph = 0;
	hr = CoCreateInstance(CLSID_FilterGraph, 0,	CLSCTX_INPROC_SERVER,
    	IID_IGraphBuilder,	reinterpret_cast<void**>(&pGraph));
	if (FAILED(hr))
	{	AMGetErrorText(hr, szErr, SZERR); return -1;	}

	hr = pGraph->RenderFile (wszFile, 0);
	if ((hr == S_OK) || (hr == VFW_S_PARTIAL_RENDER))
	{
		// Analyse the filters
		IEnumFilters *pEnumF = 0;
		IBaseFilter *pF[MAXFILTERS], *cF;
        FILTER_INFO FilterInfo, cFI;
		IPin	*pP[MAXPINS], *cP;
		PIN_INFO PinInfo, cPI;
		ULONG nbF, nbP, nSplitter;
		char szName[MAXPATH], *p;
		AM_MEDIA_TYPE MType;

		pGraph->EnumFilters (&pEnumF);
		memset (pF, 0, MAXFILTERS * sizeof (IBaseFilter *));
		pEnumF->Next(MAXFILTERS, pF, &nbF);
		// We consider that 4 filters max means audio file
		pai->bFileAudio = (nbF<=4);

		if (nbF)
        {
			// If ASF filetype, we know that we have to study the last filter
			if (pai->iFileType == ftASF)
            {
				IEnumPins *pEnumP = 0;
				pF[nbF-1]->EnumPins (&pEnumP);
				memset (pP, 0, MAXPINS * sizeof (IPin *));
				pEnumP->Next(MAXPINS, pP, &nbP);
                pEnumP->Release();
            }

			// First, we search the AVI Splitter (audio&video) filter
            // to try obtain the file format
            // Notice : the filters are in reverse order, nbF-1 = last one
            // i=1 to avoid the "Filename"
			else for (UINT i=1 ; i<=2 ; i++)
            {
				IEnumPins *pEnumP = 0;
				nSplitter = nbF-1-i;

				pF[nSplitter]->EnumPins (&pEnumP);
				memset (pP, 0, MAXPINS * sizeof (IPin *));
				pEnumP->Next(MAXPINS, pP, &nbP);

				if (bDetailled)
        	    {
	    		    hr = pF[nSplitter]->QueryFilterInfo(&FilterInfo);
					strcpy (szName, WideCharToString(FilterInfo.achName).c_str());
	    	        if (strstr (szName, "MPEG"))	// For "Ligos MPEG splitter"
    	    	    	strcpy (pai->szFileType, "MPEG");
        	    	else
	        	    {
						p = strchr (szName, ' ');
                        if (p && !strchr(szName, '\\'))	// Seems to be a valid filter
                        {
							*p = '\0';
    				   		strcpy (pai->szFileType, szName);
                        }
					}
		        	FilterInfo.pGraph->Release();
        	    }

                pEnumP->Release();
				if (nbP == i+2-pai->bFileAudio)	// (2 for 1st filter, 3 for 2nd filter)
               		break;
			}

			// Then we study output pin to find audio & video filter type

			for (int i=nbP-1 ; i>=0 ; i--)
			{
				pP[i]->QueryPinInfo(&PinInfo);
				strcpy (szName, WideCharToString(PinInfo.achName).c_str());
				pP[i]->ConnectedTo(&cP);
                if (PinInfo.dir && cP)	// Output & connected pin
                {
					pP[i]->ConnectionMediaType(&MType);
					cP->QueryPinInfo(&cPI);
    	            cF = cPI.pFilter;
	    		    hr = cF->QueryFilterInfo(&cFI);
					strcpy (szName, WideCharToString(cFI.achName).c_str());
					p = strrchr (szName, ' ');
					if (p)	*p = '\0';

					if (MType.majortype == MEDIATYPE_Video)
                    {
						if (bDetailled)
			            {
							// FourCC GUID
							if (!MType.subtype.Data2 && (MType.subtype.Data3==16))
									*(DWORD *)pai->szVC = MType.subtype.Data1;
							else	strcpy (pai->szVCname, szName);
                        }
                        pai->wVCsupp = ftSUP;
                    }
	                else if (MType.majortype == MEDIATYPE_Audio)
    	            {
						int as = 0;
						if (bDetailled)
                        {
							as = pai->wAStreamsNb++;
	    				   	strcpy (pai->a[as].szACname, szName);
                        }
                        pai->a[as].wACsupp = ftSUP;
					}
	                else if (MType.majortype == MEDIATYPE_Midi)
    	            {
						int as = 0;
						if (bDetailled)
                        {
							as = pai->wAStreamsNb++;
	    				   	strcpy (pai->a[as].szACname, "Midi");
                        }
                        pai->a[as].wACsupp = ftSUP;
					}

					cFI.pGraph->Release();
					cPI.pFilter->Release();
					cP->Release();
//					CoTaskMemFree(pMType);	// Seem Unnecessary, cause a bug in ntdll.dll
				}
		        PinInfo.pFilter->Release();
				pP[i]->Release();
			}

			for (int i=nbF-1 ; i>=0 ; i--)
				pF[i]->Release();
		}
		pEnumF->Release();
	}

	if (hr)
	{	AMGetErrorText(hr, szErr, SZERR); return -1;	}

	pGraph->Release();
	return hr;							// S_OK (0) if ok
}

// Try to obtain file info using DirectShow (available from DX8)
// -----------------------------------------------------------

int GetDSHOWinfo (wchar_t *wszFile)
{
	BOOL	bFirstAudio;
	HRESULT hr;
	IMediaDet *pDet;
    long Streams = 0;
//    long VideoStream = -1;
	AM_MEDIA_TYPE MType;

	// Create the System Device Enumerator.
	pDet = NULL;
	hr = CoCreateInstance(CLSID_MediaDet, NULL, CLSCTX_INPROC_SERVER,
		IID_IMediaDet, (void **)&pDet);
	if (FAILED(hr))
	{	AMGetErrorText(hr, szErr, SZERR); return -1;	}

    hr = pDet->put_Filename (wszFile);
	if (FAILED(hr))
	{	AMGetErrorText(hr, szErr, SZERR);	return -1;	}

    // Find the video and audio streams

	bFirstAudio = true;
    hr = pDet->get_OutputStreams (&Streams);
    for (int i = 0 ; i < Streams ; i++)
    {
		double	sec;

        pDet->put_CurrentStream (i);
		memset (&MType, 0, sizeof(MType));
	    hr = pDet->get_StreamMediaType (&MType);
	    hr = pDet->get_StreamLength (&sec);

        if (MType.majortype == MEDIATYPE_Video)
		{
			VIDEOINFOHEADER		*pVIH;
			VIDEOINFOHEADER2	*pVIH2;
			GUID	ft = MType.formattype;

//			VideoStream = i;

			pai->dwVSec = (DWORD)sec;
			if ((ft==FORMAT_MPEGVideo) || (ft==FORMAT_VideoInfo))
            {
				pVIH = (VIDEOINFOHEADER *) MType.pbFormat;
				pai->dwWidth = pVIH->bmiHeader.biWidth;
				pai->dwHeight = pVIH->bmiHeader.biHeight;
                if (pVIH->AvgTimePerFrame)	// 0 in Matroska files
					pai->dwFps = ((double)10000000000) / pVIH->AvgTimePerFrame;
			}
			else if ((ft==FORMAT_MPEG2Video) || (ft==FORMAT_VideoInfo2))
			{
				pVIH2 = (VIDEOINFOHEADER2 *) MType.pbFormat;
				pai->dwWidth = pVIH2->rcSource.right;
				pai->dwHeight = pVIH2->rcSource.bottom;
				pai->dwVAvgBPS = pVIH2->dwBitRate/8;
            }
        }
		else if (MType.majortype == MEDIATYPE_Audio)
        {
			WAVEFORMATEX		*pWF;
			if (MType.formattype == FORMAT_WaveFormatEx)
			{
				if (bFirstAudio)
				{
					pai->wAStreamsNb = 0;	// In case of already computed in DSHOWtest()
					bFirstAudio = false;
				}
				int	as = pai->wAStreamsNb++;

				pai->a[as].dwASec = (DWORD)sec;
				pWF = (WAVEFORMATEX *) MType.pbFormat;
				pai->a[as].wAC = pWF->wFormatTag;
				strcpy (pai->a[as].szACname, "");	// To allow obtaining a correct name
				pai->a[as].dwAAvgBPS = pWF->nAvgBytesPerSec;
				pai->a[as].dwASps = pWF->nSamplesPerSec;
				pai->a[as].wAChannels = pWF->nChannels;
/*		char	szMess[100];
		wsprintf (szMess, "%d : %s", pai->a[as].wAC, pai->a[as].szACname);
		ShowMessage (szMess);
*/			}
        }
    }

	pDet->Release();
	// Returns an error if no video stream found
//	return (VideoStream != -1 ? 0 : VFW_E_INVALIDMEDIATYPE);
	return 0;
}

// Calculate a FileQuality ratio (percentage)
// -----------------------------------------------------------

WORD CalcFQ ()
{
	WORD	fq,
    		fps,
    		bps,
    		perc,
    		min,
            max;
	int		val;

	// 20% on Video FrameRate. Min = 20 fps, Max = 30 fps
    fps = pai->dwFps / 1000;
    if (fps)
    {
		perc = GetPrivateProfileInt("Quality", "VideoFrameratePerc", 20, "avicodec.ini");
		min = GetPrivateProfileInt("Quality", "VideoFramerateMin", 20, "avicodec.ini");
		max = GetPrivateProfileInt("Quality", "VideoFramerateMax", 30, "avicodec.ini");
		val = perc * (fps - min) / (max - min);
    	if (val < 0) 	val=0;
	    if (val > perc) val=perc;
    	fq = val;
    }
    else	fq = 0;

	// 30% on Video Resolution. Min=TV 160*120, Med=VCD 320*240, Max=640*480
    // To ease calculation (to not use sqrt (), only Width is taken

	perc = GetPrivateProfileInt("Quality", "VideoWidthPerc", 30, "avicodec.ini");
	min = GetPrivateProfileInt("Quality", "VideoWidthMin", 160, "avicodec.ini");
	max = GetPrivateProfileInt("Quality", "VideoWidthMax", 640, "avicodec.ini");

	val = perc * (pai->dwWidth - min) / (max - min);
    if (pai->dwWidth)
    {
	    if (val < 0) 	 val=0;
    	if (val > perc) val=perc;
	    fq += val;
	}

	// 30% on Video BitRate. Min = 500 Kbps, Max = 2000 Kbps for Mpeg4, 4000 Kbps for Mpeg2
    if (pai->dwVAvgBPS)
    {
		perc = GetPrivateProfileInt("Quality", "VideoBitratePerc", 30, "avicodec.ini");
		min = GetPrivateProfileInt("Quality", "VideoBitrateMin", 500, "avicodec.ini");
		max = GetPrivateProfileInt("Quality", "VideoBitrateMax", 2000, "avicodec.ini");

		bps = pai->dwVAvgBPS * 8 / 1000;
		val = perc * (bps - min) / (max - min);
    	if (val < 0) 	val=0;
	    if (val > perc) val=perc;
    }
    else if (fq)	val=perc/2;				// Default value if not defined
    else	val = 0;
	// I consider that for equivalent bitrate, quality of Mpeg1/2 is half of Mpeg4
	if (pai->iFileType == ftMPG)
		val /= 2;
    fq += val;

	// 20% on Audio BitRate. Min = 96 Kbps, Med= 128 Kbps, Max = 192 Kbps
	if (fq)								// Video file
    {
		perc = GetPrivateProfileInt("Quality", "AudioBitratePerc", 20, "avicodec.ini");
		min = GetPrivateProfileInt("Quality", "AudioBitrateMin", 96, "avicodec.ini");
		max = GetPrivateProfileInt("Quality", "AudioBitrateMax", 192, "avicodec.ini");

	    if (pai->a[0].dwAAvgBPS)
    	{
			bps = pai->a[0].dwAAvgBPS * 8 / 1000;
			val = perc * (bps - min) / (max - min);
	    	if (val < 0) 	val=0;
		    if (val > perc) val=perc;
	    }
    	else val=perc/2;					// Default value if not defined
	    fq += val;
    }
    else						// Audio file
    {
		perc = GetPrivateProfileInt("Quality", "AudioFreqPerc", 40, "avicodec.ini");
		min = GetPrivateProfileInt("Quality", "AudioFreqMin", 5, "avicodec.ini");
		max = GetPrivateProfileInt("Quality", "AudioFreqMax", 64, "avicodec.ini");

		// 100% on Audio BitRate. Min = 5 Hz, Med= 32 Hz, Max = 64 Hz
		bps = pai->a[0].dwASps / 1000;
		val = perc * (bps - min) / (max - min);
    	if (val < 0) 	val=0;
	    if (val > perc) val=perc;
		fq = val;

		perc = 100 - perc;
		min = GetPrivateProfileInt("Quality", "AudioBitrateMin", 96, "avicodec.ini");
		max = GetPrivateProfileInt("Quality", "AudioBitrateMax", 192, "avicodec.ini");

		bps = pai->a[0].dwAAvgBPS * 8 / 1000;
		val = perc * (bps - min) / (max - min);
    	if (val < 0) 	val=0;
	    if (val > perc) val=perc;

	    fq += val;
    }

    return fq;
}

// Completion of the data structure from the existing elements
// -----------------------------------------------------------

int FileInfoFill ()
{
	int	n = min (pai->wAStreamsNb, MAXAUDIOSTREAMS);

	if (!*pai->szVC)					// If no VideoCodec, then audo file
		pai->bFileAudio = true;

	// Find if the video codec is supported by the system

	if (*pai->szVC && (pai->wVCsupp==ftUNS))
    {
		ICINFO		icinfo;

		pai->wVCsupp = ICInfo (ICTYPE_VIDEO, *(DWORD *)pai->szVC, &icinfo) ? ftSUP : ftUNS;
		if (pai->wVCsupp==ftSUP)
			strcpy (pai->szVCdriver, WideCharToString (icinfo.szDriver).c_str());
    }

	// Search detailled name and download url for this video codec

	if (!*pai->szVCname && *pai->szVC)
		strcpy (pai->szVCname, searchVCname (pai->szVC));
	if (!*pai->szVCurl && *pai->szVC)
		strcpy (pai->szVCurl, searchVCurl (pai->szVC));

	// Complete video info

	if (!pai->wAspRatio && pai->dwHeight)// To avoid possible "Divide per zero" error
		pai->wAspRatio = 100 * pai->dwWidth / pai->dwHeight;
	if (!*pai->szAspRatio && pai->wAspRatio)
		strcpy (pai->szAspRatio, searchAspRatio (pai->wAspRatio));

	// Audio calculation (before video because more info in AVI)

	if (!pai->a[0].dwASec && pai->dwFileDuration)	// Needed for ASF
		pai->a[0].dwASec = pai->dwFileDuration;
	// If 1 audio stream but looks incorrect (<1 mn or >3 hours) & video time available
	if ((n==1) && ((pai->a[0].dwASec < 60) || (pai->a[0].dwASec > 3*3600))
    		 && pai->dwFramesNb && pai->dwFps)
		pai->a[0].dwASec = pai->dwFramesNb * 1000 / pai->dwFps;
    if (pai->bFileAudio && !pai->a[0].dwASec && pai->a[0].dwAAvgBPS)
		pai->a[0].dwASec = pai->a[0].dwASize / pai->a[0].dwAAvgBPS;

	pai->dwATotSize = 0;
	for (int as=0 ; as<n ; as++)
	{
		// Find if the audio codec is supported by the system

		if (pai->a[as].wAC && (pai->a[as].wACsupp==ftUNS))
	    {
			ACMFORMATTAGDETAILS aftd;

			memset (&aftd, 0, sizeof (ACMFORMATTAGDETAILS));
			aftd.cbStruct = sizeof (ACMFORMATTAGDETAILS);
			aftd.dwFormatTag = pai->a[as].wAC;
			pai->a[as].wACsupp = !acmFormatTagDetails (NULL, &aftd, ACM_FORMATTAGDETAILSF_FORMATTAG) ? ftSUP : ftUNS;
// 10/02/2003 : I prefer the original name (ASF)
			if ((pai->a[as].wACsupp==ftSUP) && !*pai->a[as].szACname)	// We ask the driver for the codec name
				strcpy (pai->a[as].szACname, aftd.szFormatTag);
	    }

		// Search detailled name and download url for this audio codec

		if (!*pai->a[as].szACname && pai->a[as].wAC)
			strcpy (pai->a[as].szACname, searchACname (pai->a[as].wAC));
		if (!*pai->a[as].szACurl && pai->a[as].wAC)
			strcpy (pai->a[as].szACurl, searchACurl (pai->a[as].wAC));

		if (!pai->a[as].dwASec && pai->a[0].dwASec)
           	pai->a[as].dwASec = pai->a[0].dwASec;
		if (!pai->a[as].dwASize && pai->a[as].dwAAvgBPS && pai->a[as].dwASec)
	    {
			pai->a[as].dwASize = pai->a[as].dwAAvgBPS * pai->a[as].dwASec;
			pai->dwATotSize += pai->a[as].dwASize;
        }
		else if (!pai->a[as].dwAAvgBPS && pai->a[as].dwASize && pai->a[as].dwASec)
			pai->a[as].dwAAvgBPS = pai->a[as].dwASize / pai->a[as].dwASec;
		if (!pai->a[as].dwASnb && pai->a[as].dwASec && pai->a[as].dwASps)
           	pai->a[as].dwASnb = pai->a[as].dwASec * pai->a[as].dwASps;
    }
	if (n < pai->wAStreamsNb)		// We estimate the size to be the same as the 1st audio stream
		for (int i=n ; i<pai->wAStreamsNb ; i++)
            pai->dwATotSize += pai->a[0].dwASize;

	if (!pai->dwVSec && pai->dwFramesNb && pai->dwFps)
		pai->dwVSec = pai->dwFramesNb * 1000 / pai->dwFps;
	if (!pai->dwVSec && pai->dwFileDuration)
		pai->dwVSec = pai->dwFileDuration;
	if (!pai->dwFileDuration && pai->dwVSec)
		pai->dwFileDuration = pai->dwVSec;
	if (!pai->dwFileDuration && pai->a[0].dwASec)
		pai->dwFileDuration = pai->a[0].dwASec;
	if (!pai->a[0].dwASec && pai->dwVSec)
		pai->a[2].dwASec = pai->a[1].dwASec = pai->a[0].dwASec = pai->dwVSec;

	// Video calculation

	if (!pai->dwVSize && pai->dwVAvgBPS && pai->dwVSec)
		pai->dwVSize = pai->dwVAvgBPS * pai->dwVSec;
	if (!pai->dwVSize && pai->dwFileTheoSize && pai->dwATotSize)
		pai->dwVSize = pai->dwFileTheoSize - pai->dwFileHeadSize - pai->dwATotSize;
	if (!pai->dwVSize && pai->dwFileRealSize && pai->dwATotSize && (pai->dwFileRealSize > pai->dwATotSize))
		pai->dwVSize = pai->dwFileRealSize - pai->dwFileHeadSize - pai->dwATotSize;
	if (!pai->dwVSize && !pai->wAStreamsNb) // No audio
		pai->dwVSize = (pai->dwFileTheoSize ? pai->dwFileTheoSize :
        				pai->dwFileRealSize) - pai->dwFileHeadSize;

	if (!pai->dwVAvgBPS && pai->dwVSize && pai->dwVSec)
		pai->dwVAvgBPS = pai->dwVSize / pai->dwVSec;

	if (!pai->dwFramesNb && pai->dwFps && pai->dwVSec)
		pai->dwFramesNb = pai->dwFps * pai->dwVSec / 1000;

	if (!pai->dwFps && pai->dwFramesNb && pai->dwVSec)
		pai->dwFps = 1000 * pai->dwFramesNb / pai->dwVSec;

	if (!pai->dwFileTheoSize && pai->dwVSize && pai->dwATotSize)	// Debug purpose
		pai->dwFileTheoSize =  pai->dwFileHeadSize + pai->dwVSize + pai->dwATotSize;

	pai->wFileQuality = CalcFQ ();

	return 0;
}

// Find the type of multimedia file
// by reading the 1st 4 bytes
// Return 0 for AVI, 1 for MPG, 2 for OGG, 3 for Real, 4 for DirectShow
// 5 for ASF
// -----------------------------------------------------------

#define SMALLHEADSIZE	0x80

filetype FileType (wchar_t *wszFile, BOOL bSaveHeader)
{
	FILE	*fhout;
	char	*bfr,
    		szBuf[SMALLHEADSIZE],
    		szOutFile[255];
	DWORD	*pdw;
	int		pos,
		    dwFileSize;
	BOOL	bTest;
	SYSTEMTIME	st;
	HANDLE	hf;
	BY_HANDLE_FILE_INFORMATION	bhfi;
	DWORD	l;
	LARGE_INTEGER	qwSize;

	pai->iFileType = ftUNK;
	// Use of CreateFile to enable very big files access (> 4 Gb)
	hf = CreateFileW (wszFile, GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if (hf == INVALID_HANDLE_VALUE)
	{
		LPSTR lpMsgBuf;

		FormatMessage(
		    FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
		    NULL,
		    GetLastError(),
		    MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
		    (LPTSTR) &lpMsgBuf,
		    0,
		    NULL
		);
//    	strcpy (szErr, szErrorString[7]);
    	strcpy (szErr, lpMsgBuf);
		LocalFree( lpMsgBuf );
        return ftUNK;
    }

	// Read real file size
	GetFileInformationByHandle (hf, &bhfi);
	pai->dwFileRealSize = bhfi.nFileSizeLow;
	if (!bhfi.nFileSizeLow)				// A file of 0 byte has an unknown format ...
		return ftUNK;
	qwSize.LowPart = bhfi.nFileSizeLow;
	qwSize.HighPart = bhfi.nFileSizeHigh;
	pai->dwFileRealSizeKb = qwSize.QuadPart>>10;

	// Read file date
	FileTimeToSystemTime (&bhfi.ftLastWriteTime, &st);
	// Convert it to locale format
	GetDateFormat (LOCALE_USER_DEFAULT, DATE_SHORTDATE, &st, NULL, pai->szFileDate, 11);
	// Convert it to yyyy-MM-dd HH:MM:SS format
	wsprintf(pai->szFileDate, "%4d-%02d-%02d %02d:%02d:%02d", st.wYear, st.wMonth, st.wDay,
				st.wHour, st.wMinute, st.wSecond);

	ReadFile (hf, szBuf, SMALLHEADSIZE, &l, NULL);

    pos = 0;
	pdw = (DWORD *)szBuf;
	bTest = TRUE;
	while (bTest)
	{
		switch (*pdw)
		{
		case mmioFOURCC('R','I','F','F'):
    		pdw += 2;
        	if (*pdw == mmioFOURCC('A','V','I',' '))
	        {
				pai->iFileType = ftAVI;
				strcpy (pai->szFileType, "AVI");
				bTest = FALSE;
	        }
    	    else if (*pdw == mmioFOURCC('C','D','X','A'))	// Container
			// Explanations on CDXA format :	// For in general MPG files
            // http://xcd.sourceforge.net/
			// http://www.wsu.edu/~benp/mcfcd.htm
			// Source code of cdxa2mpeg.c included in :
            // http://www.vcdimager.org
//	    		pdw += 15;
				bTest = FALSE;	// I force the end without FileType to allow a detection by DirectShow
			break;
		case INVDW(MPEG_PACK_SC):		// MPEG System
		case INVDW(MPEG_SEQUENCE_SC):	// MPEG Video
			pai->iFileType = ftMPG;
			strcpy (pai->szFileType, "MPG");
			bTest = FALSE;
			break;
		case mmioFOURCC('O','g','g','S'):
			pai->iFileType = ftOGG;
			strcpy (pai->szFileType, "OGG");
			bTest = FALSE;
			break;
		case mmioFOURCC('.','R','M','F'):
			pai->iFileType = ftRMF;
			strcpy (pai->szFileType, "RMF");
			bTest = FALSE;
			break;
		case mmioFOURCC(0x30,0x26,0xB2,0x75):
			pai->iFileType = ftASF;
			strcpy (pai->szFileType, "ASF");
			bTest = FALSE;
			break;
		case mmioFOURCC(0x1A,0x45,0xDF,0xA3):	// EBML signature
        // http://www.matroska.org/technical/specs/index.html
			pai->iFileType = ftMKV;
			strcpy (pai->szFileType, "MKV");
			bTest = FALSE;
			break;
		case mmioFOURCC('F','L','V',0x1):	// FLV version 1.x
			pai->iFileType = ftFLV;
			strcpy (pai->szFileType, "FLV");
			bTest = FALSE;
			break;
		default:
			pos++;
            if (pos == SMALLHEADSIZE)
				bTest = FALSE;
			pdw = (DWORD *)&szBuf[pos];
		}
	}
 	if (pai->iFileType == ftUNK)
    {
//		char	szMess[100];
		if (!DSHOWtest (wszFile, true))	// Playable with DirectShow
        {
//			if (stricmp(&szFile[strlen(szFile)-3], "mp3"))
//			if (((AnsiString)wszFile).Pos("mp3"))
			if (wcsstr(wszFile, L".mp3"))
            {
				pai->iFileType = ftMP3;
				strcpy (pai->szFileType, "MP3");
//				strcpy (pai->szFileUrl, "http://www.microsoft.com/windows/windowsmedia/players.asp");
            }
            else
            {
				pai->iFileType = ftDSH;
				strcpy (pai->szFileType, "DSH");
//				strcpy (pai->szFileUrl, "http://www.microsoft.com/windows/windowsmedia/players.asp");
            }
        }
//        else	strcpy (szErr, "Unknown format");
    }
    // Weblink to a nice codec pack (instead of media player)
//	strcpy (pai->szFileUrl, "http://yatoshi.com/");

	// Save header file for future reference

	if (bSaveHeader && !((AnsiString)wszFile).Pos(".hdr"))
    {
		strcpy (szOutFile, ((AnsiString)wszFile).c_str());
	    strcat (szOutFile, ".hdr");
		fhout = fopen (szOutFile, "wb");
		if (fhout == NULL)
        {
			wsprintf(szBuf, szErrorString[18], szOutFile);
			ShowMessage(szBuf);
        }
        else
        {
			dwFileSize = (pai->iFileType == ftMPG ? MAXSAVEDHEADER : 2*MAXHEAD);
			try {	bfr = new char [dwFileSize];	}
			catch (...)
			{	ShowMessage(szErrorString[0]); return pai->iFileType;		}

            SetFilePointer(hf, 0, NULL, FILE_BEGIN);
			ReadFile (hf, bfr, dwFileSize, &l, NULL);
			fwrite (bfr, 1, dwFileSize, fhout);// Write BOF

            SetFilePointer(hf, -dwFileSize, NULL, FILE_END);
			ReadFile (hf, bfr, dwFileSize, &l, NULL);
			fwrite (bfr, 1, dwFileSize, fhout);// Write EOF

			fclose (fhout);
			delete bfr;
	    }
	}
	CloseHandle (hf);

	return pai->iFileType;
}

