#include <vcl.h>
#pragma hdrstop

#pragma warn -pin						// Suppr warning 'Init is partially bracketed'
#pragma package(smart_init)
#pragma link "TntClipBrd"
#pragma link "TntComCtrls"
#pragma link "TntDialogs"
#pragma link "TntStdCtrls"
#pragma resource "*.dfm"

#define __MFC_COMPAT__

#include <vcl\Clipbrd.hpp>
#include <dir.h>						// findfirst
#include <dos.h>						// FA_DIREC
#include <stdio.h>						// fopen
#include <vfw.h>						// ACMDRIVERDETAIL
#include <ShlObj.h>

#include "Main.h"
#include "Options.h"
#include "About.h"
#include "asfinfo.h"
#include "fileinfo.h"
#include "multinfo.h"
              
// -----------------------------------------------------------
// Global data
// -----------------------------------------------------------

TMainForm *MainForm;
HWND hWndNextViewer=NULL;				// Clipboard viewer

struct FileInfo *pai;					// Allocated here, filled in FileInfo.cpp

struct COLUMN col[MAXCOL]
=
{
FNAM, NULL,260, 'A',
VFCC, NULL,60, 'A',
VCON, NULL,120, 'A',
VCOS, NULL,90, 'A',
VRES, NULL,60, 'N',
VRAT, NULL,60, 'N',
VFRN, NULL,60, 'N',
VFRQ, NULL,60, 'N',
VTIM, NULL,60, 'A',
VARA, NULL,80, 'A',
VSIZ, NULL,60, 'N',
ASTR, NULL,70, 'N',
ATSZ, NULL,60, 'N',
A1COI, NULL,70, 'A',
A1CON, NULL,120, 'A',
A1COS, NULL,90, 'A',
A1TIM, NULL,60, 'A',
A1CHA, NULL,60, 'N',
A1SNB, NULL,60, 'N',
A1FRQ, NULL,60, 'N',
A1RAT, NULL,60, 'N',
A1SIZ, NULL,60, 'N',
A2COI, NULL,70, 'A',
A2CON, NULL,120, 'A',
A2COS, NULL,90, 'A',
A2TIM, NULL,60, 'A',
A2CHA, NULL,60, 'N',
A2SNB, NULL,60, 'N',
A2FRQ, NULL,60, 'N',
A2RAT, NULL,60, 'N',
A2SIZ, NULL,60, 'N',
FTYP, NULL,60, 'A',
FRSZ, NULL,80, 'N',
FTSZ, NULL,80, 'N',
FQUA, NULL,60, 'N',
FDAT, NULL,60, 'A',
FDRM, NULL,10, 'A',
FINF, NULL,110, 'A',
};

BOOL	bOptions[10];

__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
	int pc = ParamCount();
	OSVERSIONINFO osvi;

    InitCommonControls();	// Loads COMCTL32.DLL

	ZeroMemory( &osvi, sizeof( osvi ) );
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osvi);
    bWin9x = (osvi.dwMajorVersion==4);	//	The operating system is Windows NT 4.0, Windows Me, Windows 98, or Windows 95.

#ifdef USEAVIFUNC
	AVIFileInit ();
#endif

	Application->HintHidePause = 4000;	// 2500 par dfaut (2.5 sec)

	// Load parameters saved in registry
	bool	bInstalled = LoadParam ();

	// Listview columns init (after LoadParam() which initialize colId[])
	InitColumns (false);

	// Load language texts
	if (!*szLang)
    {
		WORD lgid = PRIMARYLANGID(LANGIDFROMLCID(GetUserDefaultLCID ()));
		WORD sublgid = SUBLANGID(LANGIDFROMLCID(GetUserDefaultLCID ()));

		// include/winnt.h
		strcpy (szLang,
        				lgid == LANG_ARABIC ? "Arabic" :
        				lgid == LANG_CHINESE ?
        					(sublgid==SUBLANG_CHINESE_SIMPLIFIED ? "Chinese simplified" : "Chinese traditional") :
        				lgid == LANG_CZECH ? "Czech" :
        				lgid == LANG_DANISH ? "Danish" :
        				lgid == LANG_DUTCH ? "Nederlands" :
        				lgid == LANG_FRENCH ? "Franais" :
						lgid == LANG_GERMAN ? "Deutsch" :
						lgid == LANG_GREEK ? "Greek" :
						lgid == LANG_ITALIAN ? "Italiano" :
						lgid == LANG_HUNGARIAN ? "Hungarian" :
						lgid == LANG_KOREAN ? "Korean" :
						lgid == LANG_POLISH ? "Polski" :
                        lgid == LANG_PORTUGUESE ?
                        	(sublgid==SUBLANG_PORTUGUESE_BRAZILIAN ? "Brasileiro" : "Portugus") :
						lgid == LANG_ROMANIAN ? "Romana" :
						lgid == LANG_RUSSIAN ? "Russian" :
						lgid == LANG_SPANISH ?
                        	(sublgid==SUBLANG_SPANISH_ARGENTINA ? "Espaol-SudA" : "Espaol"):
						lgid == LANG_TURKISH ? "Trke" :
                        lgid == LANG_UKRAINIAN ? "Ukrainian" :
							        		"English");
    }

	if (InitText () == -1)
    {
		ShowMessage (szErr);
		exit (-1);
	}

    if ((pc == 1) && (ParamStr(1)=="/u"))	// If uninstall -> Registry cleaning
    {
		OptionsForm->UpdateAssoc(0, false);
		OptionsForm->UpdateAssoc(1, false);
		exit (-1);						// and exit
    }

	// If first installation, I set the association with files & folders
    // 2005 10 23 : deactivated because a lots of people disagree
/*	if (!bInstalled)
    {
		OptionsForm->UpdateAssoc(0, true);
		OptionsForm->UpdateAssoc(1, true);
	}
*/
	// Load codec information from file
	if (InitCodecs (szInstallDir) == -1)// Codec file not found
    {
		ShowMessage (szErr);
		exit (-1);
    }

	// COM init for DirectX access
	CoInitialize(NULL);

	// If there is 1 or more parameters on commandline, analyze it

    if (pc >= 1)
    {
		int Argc;
	    wchar_t **Argv;
	    Argv = CommandLineToArgvW(GetCommandLineW(), &Argc );

/*		#define NEXT_ARG ((((*Argv)[2]) == TEXT('\0')) ? (--Argc, *++Argv) : (*Argv)+2)
		while (++Argv, --Argc) {
			if (Argv[0][0] == TEXT('/')) {
            	switch (Argv[0][1]) {
            	case TEXT('e'): 		// Export
                	username = NEXT_ARG;
	                break;
    	        }
			}
		}*/
		wcscpy(wszInitDir, *++Argv);
	    GlobalFree((HGLOBAL)Argv);

		// ParamsStr is not unicode compliant
//		ParamStr(1).WideChar(wszInitDir, 2*MAXPATH);
//        MessageBoxW(NULL, wszInitDir, L"", 0);
		ExecCmdLine();
		if (ParamStr(2)=="/e")
        {
			ExpFileListBtnClick(NULL);
			exit(-1);
        }
		PostMessage(Handle, WM_AC_SELECT, 0, 0);	// Select 1st line
    }
}

__fastcall TMainForm::~TMainForm()
{
	CoUninitialize();
	SaveParam ();
}

// Execute command line parameters (stored in wszInitDir)

void __fastcall TMainForm::ExecCmdLine()
{
	int		a;

	a = GetFileAttributesW(wszInitDir);
	if (!*wszInitDir || (a == 0xFFFFFFFF))	// No CmdLine or error with file
    	return;

	if (a & FILE_ATTRIBUTE_DIRECTORY)	// It is a directory
		ScanDir (wszInitDir, ChScanRec->Checked, false);
	else AddFile (wszInitDir, false);	// It is a file

	if (LV->Items->Count)
        LV->Items->Item[ligIndex]->Selected = true;

	BringWindowToTop(Handle);	// In case it has disappear
}

// Init of colums
// -----------------------------------------------------------

void __fastcall TMainForm::InitColumns(bool bOnlyCaption=true)
{
	for (int i=0 ; i<NBCOL ; i++)
		if (colId[i] >= 0)
		{
			LV->Columns->Items[i]->Caption = AnsiString (col[colId[i]].szColName);
            if (!bOnlyCaption)
				LV->Columns->Items[i]->Width = col[colId[i]].iColWidth;
		}
        else
		{
			LV->Columns->Items[i]->Caption = "";
			LV->Columns->Items[i]->Width = 0;	// If empty, we resize to zero
		}
}

void __fastcall TMainForm::FormDestroy(TObject *Sender)
{
#ifdef USEAVIFUNC
	AVIFileExit ();
#endif
}

// Clear List
// -----------------------------------------------------------

void __fastcall TMainForm::ClearList()
{
	int	n = LV->Items->Count;
	while (n > 0)
	{
		TTntListItem *p = LV->Items->Item[--n];
		delete p->Data;
		p->Delete ();
	}
}

// File select
// OpenDialog based on TTntOpenDialog to get Unicode support :
// http://www.tntware.com/delphicontrols/
// Another Unicode lib : http://unicode.soft-gems.net/Library.php
// -----------------------------------------------------------

void __fastcall TMainForm::SelFileBtnClick(TObject *Sender)
{
	char	szFilter[200];

	// Create a filter in using FileExtension listed in codecs.xml
	wsprintf (szFilter, szOtherString[10], szFileExtension);

	OpenDialog1->Filter = szFilter;
	OpenDialog1->InitialDir = wszInitDir;
	if (!OpenDialog1->Execute())
		return;
	GetCurrentDirectoryW (MAXPATH, wszInitDir);

	if (ChClearList->Checked)
		ClearList();

//	if (!AddFile (OpenDialog1->FileName.c_str(), ChSaveHeader->Checked))
//        LV->Items->Item[ligIndex]->Selected = true;
	for(int i=0 ; i<OpenDialog1->Files->Count ; i++)
         if (!AddFile (OpenDialog1->Files->Strings[i], ChSaveHeader->Checked))
			LV->Items->Item[ligIndex]->Selected = true;
}

// Select directory code
// Extracted from TBffolder by Torsten Johann (t-johann@gmx.de)
// Use of http://libunicows.sourceforge.net/ to make it work under win9x
// http://msdn.microsoft.com/msdnmag/issues/01/10/mslu/default.aspx
// http://msdn.microsoft.com/library/default.asp?url=/library/en-us/mslu/winprog/microsoft_layer_for_unicode_on_windows_95_98_me_systems.asp
// http://msdn.microsoft.com/library/default.asp?url=/library/en-us/mslu/winprog/compiling_your_application_with_the_microsoft_layer_for_unicode.asp

int __stdcall BffolderCallbackProc (HWND hwnd, UINT uMsg, LPARAM lParam, LPARAM lpData)
{
	TMainForm	*TMF = (TMainForm *)lpData;

	if (uMsg == BFFM_INITIALIZED)
	{
		SetWindowText (hwnd, szMainForm[42]);	// Caption
//		SetWindowText (hwnd, "AVIcodec");	// Caption
		SendMessage (hwnd, BFFM_ENABLEOK, 0, TRUE);
        SendMessage (hwnd, BFFM_SETSELECTIONW, true, (LPARAM)TMF->wszInitDir);
    }
	return 0;
}

void __fastcall TMainForm::SelDirBtnClick(TObject *Sender)
{
    LPMALLOC		lpMalloc;
    LPSHELLFOLDER	lpShellFolder;
    BROWSEINFOW		bi;		// Unicode version
    LPITEMIDLIST	ItemID;

	// We initialize the SHBrowseForFolder function

	if (SHGetMalloc (&lpMalloc) != NOERROR)
		return;
    if (SHGetDesktopFolder (&lpShellFolder) != NOERROR)
		return;

	// We clear the list

	if (ChClearList->Checked)
		ClearList();

	ZeroMemory (&bi, sizeof (BROWSEINFO));
	bi.ulFlags += BIF_RETURNONLYFSDIRS | BIF_USENEWUI;

	bi.hwndOwner = Application->Handle;
	bi.pszDisplayName = wszInitDir;
	bi.lpszTitle = StringToWideChar((AnsiString)szMainForm[58], wszTemp, 2*MAXPATH);
	bi.lpfn = BffolderCallbackProc;
	bi.lParam = (long)this;

	ItemID = SHBrowseForFolderW (&bi);	// Display the search directory dialog

	lpShellFolder->Release ();
	if (ItemID != NULL)
	{
		// Unicode version
		SHGetPathFromIDListW (ItemID, wszInitDir);
		lpMalloc->Free (ItemID);
		lpMalloc->Release ();

		// Futur : use of thread, using http://www.delphibasics.co.uk/RTL.asp?Name=BeginThread
		ScanDir (wszInitDir, ChScanRec->Checked, false);
		if (LV->Items->Count)
	        LV->Items->Item[0]->Selected = true;
	}
}

// Add a file in the list, return 0 if ok
// -----------------------------------------------------------

int __fastcall TMainForm::AddFile (wchar_t *wszFile, BOOL bSaveHeader)
{
	char	szBuf[MAXPATH],
    		szFile[MAXPATH];
	int		err;
    filetype	ft;
    wchar_t	*p;

	try {	pai = new struct FileInfo;	}
	catch (...)
	{	ShowMessage (szErrorString[0]); return 1;		}
	memset (pai, 0, sizeof (struct FileInfo));

	strcpy(szFile, ((AnsiString)wszFile).c_str());
	ft = FileType (wszFile, bSaveHeader);
	if (ft == ftUNK)
	{
		if (!bOptions[OPT_Silent])
        {
			wsprintf (szBuf, szErrorString[1], szErr, szFile);
			if (MessageBox(Handle, szBuf, "AVIcodec", MB_OKCANCEL | MB_ICONEXCLAMATION)
		    ==IDCANCEL)
            {
            	ChSilent->Checked = true;	// If cancel, we go in silent mode
	            bOptions[OPT_Silent] = true;
            }
//			ShowMessage (szBuf);
        }
		return 2;
	}

	err = 1;
    strcpy (szErr, szErrorString[2]);
	if (ft==ftAVI)		err = GetAVIinfo (wszFile);
	else if (ft==ftMPG)	err = GetMPGinfo (wszFile);
	else if (ft==ftOGG)	err = GetOGGinfo (wszFile);
	else if (ft==ftRMF)	err = GetRMinfo (wszFile);
	else if (ft==ftDSH)	err = GetDSHOWinfo (wszFile);
	else if (ft==ftASF)	err = GetASFinfo (wszFile);
//	else if (ft==ftMKV)	err = GetMKVinfo (wszFile);
//	else if (ft==ftMKV)	err = GetMediaInfo (wszFile);
	else if (ft==ftFLV)	err = GetFLVinfo (wszFile);
	else if (ft==ftMP3)
    {
    	err = GetDSHOWinfo (wszFile);
		pai->a[0].wAC = 0x55;
    }

	if (err && !bOptions[OPT_Silent])
	{
		wsprintf (szBuf, szErrorString[1], szErr, szFile);
		ShowMessage (szBuf);
	}
    FileInfoFill ();

	if ((pai->wVCsupp==ftUNS) || ((pai->a[0].wACsupp==ftUNS) && *pai->a[0].szACname))
		if (!ChFastScan->Checked)
        {
			// It not useful to do DSHOW test on header, and header files are something not readable by DShow
			if (!strstr (szFile, ".head") && !strstr (szFile, ".hdr"))
				DSHOWtest (wszFile, false);	// test if DirectShow can handle sound & videco
        }
        else
        {
			if (pai->wVCsupp==ftUNS)	pai->wVCsupp=ftSNV;
			if (pai->a[0].wACsupp==ftUNS)	pai->a[0].wACsupp=ftSNV;
        }

	LV->Selected = NULL;				// To not have problems in LVChange ()
	TTntListItem *pLI = MainForm->LV->Items->Add();
	pLI->Data = pai;
/*	if ((pai->bFileAudio && (pai->a[0].wACsupp==ftSUP)) ||
	    (!pai->bFileAudio && (pai->wVCsupp==ftSUP) && (pai->a[0].wACsupp==ftSUP)))
    	pLI->ImageIndex = 1;*/
	if (pai->bFileAudio && (pai->a[0].wACsupp==ftSUP))
    	pLI->ImageIndex = 4;
	// Fichier video et dont le codec audio s'il existe est support
	else if ((!pai->bFileAudio && (pai->wVCsupp==ftSUP) && (!pai->wAStreamsNb || (pai->a[0].wACsupp==ftSUP))))
    	pLI->ImageIndex = 5;
	else if (!ChFastScan->Checked)
		pLI->ImageIndex = (pai->wVCsupp==ftSUP ? 3 : (pai->a[0].wACsupp==ftSUP) ? 2 : 0);
	else   	pLI->ImageIndex = -1;

	p = wcsrchr (wszFile, '\\')+1;
	pLI->Caption = bOptions[OPT_HidePath] ? p : wszFile;// En dernier, car ensuite appel de LVChange
	ligIndex = pLI->Index;

	return 0;
}

// Explore a directory and possibly subdirectory
// -----------------------------------------------------------

void __fastcall TMainForm::ScanDir (wchar_t *wszPath, BOOL recursive, BOOL bSaveHeader)
{
	struct	_wffblk ffblk;
	int		done;
	char	szExt[4];
    wchar_t	wszDir[2*MAXPATH],
            wszFile[2*MAXPATH],
            *p;

	if (wszPath[wcslen (wszPath)-1] != L'\\')
		wcscat (wszPath, L"\\");

	// First we scan files in current directory
    // We don't scan hidden files to let them hidden ...

	wcscpy(wszFile, wszPath);
	wcscat(wszFile, L"*.*");
	done = _wfindfirst (wszFile, &ffblk, FA_RDONLY | FA_ARCH);
	while (!done)
	{
		wcscpy(wszFile, ffblk.ff_name);
		p = wcsrchr(wszFile, L'.');
        if (p && (wcslen (p)>2))		// File with an extension
        {
			strcpy (szExt, ((AnsiString)p).c_str());
    	    strlwr (szExt);
//			szExt[3] = 0;				// I keep only .+the first 2 char.
        	if (strstr (szFileExtension, szExt))
	        {
				wcscpy(wszFile, wszPath);
                wcscat(wszFile, ffblk.ff_name);
				AddFile(wszFile, bSaveHeader);
			}
        }
		done = _wfindnext(&ffblk);
	}

	if (!recursive)
		return;							// We stop

	// Second we scan directories in current directory to study them

	wcscpy(wszFile, wszPath);
	wcscat(wszFile, L"*.*");
	done = _wfindfirst (wszFile, &ffblk, FA_DIREC | FA_ARCH);
	while (!done)
	{
		if ((ffblk.ff_attrib & FA_DIREC) && (ffblk.ff_name[0] != L'.'))
		{
			wcscpy (wszDir, wszPath);
			wcscat (wszDir, ffblk.ff_name);
			wcscat (wszDir, L"\\");
			ScanDir (wszDir, recursive, bSaveHeader);
		}
		done = _wfindnext(&ffblk);
	}
}

// Add information in columns 2, 3, 4, ...
// -----------------------------------------------------------

void __fastcall TMainForm::LVInsert(TObject *Sender, TListItem *Item)
{
	char	szBuf[100];
	int		i, c;

	for (i=1 ; i<NBCOL ; i++)
	{
		c = colId[i];
		if (c == -1)
		{
			Item->SubItems->Add ("");
			continue;
		}

		strcpy (szBuf, "");
        GetColData(c, szBuf);
		Item->SubItems->Add (szBuf);
	}
}

// Get information for columns col and put it in p
// -----------------------------------------------------------

void __fastcall TMainForm::GetColData(int col, char *p)
{
	int	min;

	switch (col)
	{
	case VFCC:
		strcpy (p, pai->szVC);
		break;
	case VCON:
		strcpy (p, pai->szVCname);
		break;
	case VCOS:
		strcpy (p, pai->wVCsupp==ftUNS ? szOtherString[1] :
           		pai->wVCsupp==ftSUP ? szOtherString[0] : szOtherString[20]);
		break;
	case VRES:
		wsprintf (p, "%ld * %ld", pai->dwWidth, pai->dwHeight);
		break;
	case VRAT:
		wsprintf (p, szOtherString[2], pai->dwVAvgBPS*8/1000);
		break;
	case VFRN:
		wsprintf (p, "%d", pai->dwFramesNb);
		break;
	case VFRQ:
		if (pai->dwFps == (pai->dwFps /1000) * 1000)
				wsprintf (p, szOtherString[3], pai->dwFps/1000);
           else	wsprintf (p, szOtherString[4], pai->dwFps/1000, pai->dwFps - (int)(pai->dwFps/1000)*1000);
		break;
	case VTIM:
		min = pai->dwVSec / 60;
		wsprintf (p, "%d:%02d:%02d", pai->dwVSec/3600, min % 60, pai->dwVSec - 60 * min);
		break;
	case VARA:
		strcpy (p, pai->szAspRatio);
		break;
	case VSIZ:
		strcpy (p, szSize(pai->dwVSize));
		break;
	case ASTR:
		wsprintf (p, "%d", pai->wAStreamsNb);
		break;
	case ATSZ:
		strcpy (p, szSize(pai->dwATotSize));
		break;
	case A1COI:
		wsprintf (p, "0x%04X", pai->a[0].wAC);
		break;
	case A1CON:
		strcpy (p, pai->a[0].szACname);
		break;
	case A1COS:
		strcpy (p, pai->a[0].wACsupp==ftUNS ? szOtherString[1] :
           		pai->a[0].wACsupp==ftSUP ? szOtherString[0] : szOtherString[20]);
		break;
	case A1TIM:
		min = pai->a[0].dwASec / 60;
		wsprintf (p, "%d:%02d:%02d", pai->a[0].dwASec/3600, min % 60, pai->a[0].dwASec - 60 * min);
		break;
	case A1CHA:
		wsprintf (p, "%d", pai->a[0].wAChannels);
		break;
	case A1SNB:
		wsprintf (p, "%d", pai->a[0].dwASnb);
		break;
	case A1FRQ:
		wsprintf (p, "%d Hz", pai->a[0].dwASps);
		break;
	case A1RAT:
		wsprintf (p, szOtherString[2], pai->a[0].dwAAvgBPS*8/1000);
		break;
	case A1SIZ:
		strcpy (p, szSize(pai->a[0].dwASize));
		break;
	case A2COI:
		wsprintf (p, "0x%04X", pai->a[1].wAC);
		break;
	case A2CON:
		strcpy (p, pai->a[1].szACname);
		break;
	case A2COS:
		strcpy (p, pai->a[1].wACsupp==ftUNS ? szOtherString[1] :
           		pai->a[1].wACsupp==ftSUP ? szOtherString[0] : szOtherString[20]);
		break;
	case A2TIM:
		min = pai->a[1].dwASec / 60;
		wsprintf (p, "%d:%02d:%02d", pai->a[1].dwASec/3600, min % 60, pai->a[0].dwASec - 60 * min);
		break;
	case A2CHA:
		wsprintf (p, "%d", pai->a[1].wAChannels);
		break;
	case A2SNB:
		wsprintf (p, "%d", pai->a[1].dwASnb);
		break;
	case A2FRQ:
		wsprintf (p, "%d Hz", pai->a[1].dwASps);
		break;
	case A2RAT:
		wsprintf (p, szOtherString[2], pai->a[1].dwAAvgBPS*8/1000);
		break;
	case A2SIZ:
		strcpy (p, szSize(pai->a[1].dwASize));
		break;
	case FTYP:
		strcpy (p, pai->szFileType);
		break;
	case FRSZ:
		strcpy (p, szSize(pai->dwFileRealSizeKb, 1));
/*		char	szMess[100];
		wsprintf (szMess, "%d : %d", pai->dwFileRealSizeKb, pai->a[0].dwASize);
		ShowMessage (szMess);
*/
		break;
	case FTSZ:
		strcpy (p, szSize(pai->dwFileTheoSize));
		break;
	case FQUA:
		wsprintf (p, "%d %", pai->wFileQuality);
		break;
	case FDAT:
		strcpy (p, pai->szFileDate);
		break;
	case FDRM:
		strcpy (p, pai->bDRMlocked ? "DRM" : "");
		break;
	case FINF:
		strcpy (p, pai->szFileInfo);
		break;
	}
}

// A line in the ListBox has been selected,
// so I update the 3 lines in bottom of main window
//---------------------------------------------------------------------------

void __fastcall TMainForm::LVChange(TObject *Sender, TListItem *Item,
	  TItemChange Change)
{
	char	szBuf[200], szSupported[20];
	int		min, fps;

	if (Change != ctState)
    	return;
	if (Item->Selected)
	{
		pai = (struct FileInfo *)Item->Data;
		if (!pai)						// Happens some times ?!?
			return;

		min = pai->dwFileDuration / 60;
		wsprintf (szBuf, szOtherString[6], szSize(pai->dwFileRealSizeKb, 1), szSize(pai->dwFileTheoSize, 0, 10), pai->dwFileDuration/3600, min % 60, pai->dwFileDuration - 60 * min, pai->szFileType, pai->wAStreamsNb, pai->wFileQuality, pai->szFileInfo, pai->bDRMlocked ? "DRM" : "");
		FDetails->Text = szBuf;
//		if (*pai->szFileUrl)
//		{
			FWebBtn->Enabled = true;
//			FWebBtn->Hint = pai->szFileUrl;
//		}

		if (*pai->szVCname)
		{
			strcpy (szSupported, pai->wVCsupp==ftUNS ? szOtherString[1] :
            		pai->wVCsupp==ftSUP ? szOtherString[0] : szOtherString[20]);
            fps = pai->dwFps / 1000;
			wsprintf (szBuf, szOtherString[7], szSize(pai->dwVSize), pai->dwVAvgBPS*8/1000, fps, pai->dwFps - fps*1000, pai->dwWidth, pai->dwHeight, pai->szAspRatio, pai->szVC, pai->szVCname, szSupported);
			VDetails->Text = szBuf;
			if (*pai->szVCurl)
            {
		        VWebBtn->Enabled = true;
		        VWebBtn->Hint = pai->szVCurl;
            }
		}
        else	VDetails->Text = "";

		ADetails->Clear ();
		if (*pai->a[0].szACname)
		{
			for (int as=0 ; as<pai->wAStreamsNb ; as++)
            {
				strcpy (szSupported, pai->a[as].wACsupp==ftUNS ? szOtherString[1] :
    	        		pai->a[as].wACsupp==ftSUP ? szOtherString[0] : szOtherString[20]);
				wsprintf (szBuf, szOtherString[8], szSize(pai->a[as].dwASize), pai->a[as].dwAAvgBPS*8/1000, pai->a[as].dwASps, pai->a[as].wAChannels, pai->a[as].wAC, pai->a[as].szACname, pai->a[as].szABrType, pai->a[as].szAInfo, szSupported);
				ADetails->AddItem (szBuf, NULL);
				if (!as)
					ADetails->Text = szBuf;
            }

			if (*pai->a[0].szACurl)
            {
		        AWebBtn->Enabled = true;
		        AWebBtn->Hint = pai->a[0].szACurl;
            }
		}
//        Item->Focused = true;
	}
	else
	{
		FDetails->Text = "";
		VDetails->Text = "";
		ADetails->Clear ();
		FWebBtn->Enabled = false;
        VWebBtn->Enabled = false;
        AWebBtn->Enabled = false;
	}
}
//---------------------------------------------------------------------------

int		SortedColumn;
bool	AscDescSort[NBCOL];

void __fastcall TMainForm::LVColumnClick(TObject *Sender, TListColumn *Column)
{
	SortedColumn = Column->Index;
	AscDescSort[SortedColumn] = !AscDescSort[SortedColumn];
	LV->AlphaSort();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::LVCompare(TObject *Sender, TListItem *Item1,
	  TListItem *Item2, int Data, int &Compare)
{
	switch (SortedColumn)
	{
	case 0 :
		Compare = Item1->Caption.AnsiCompare(Item2->Caption);
		break;
	default :
    	if (col[colId[SortedColumn]].cSortType == 'A')
				Compare = Item1->SubItems->Strings[SortedColumn-1].AnsiCompare(Item2->SubItems->Strings[SortedColumn-1]);
		else	Compare = atoi(Item1->SubItems->Strings[SortedColumn-1].c_str()) - atoi(Item2->SubItems->Strings[SortedColumn-1].c_str());
	}
	if (AscDescSort[SortedColumn]) Compare = -Compare;
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::AboutBtnClick(TObject *Sender)
{
	char	szBuf[100];
    UINT 	i, j;

	for (i=j=0 ; i<=strlen(szMainForm[8]) ; i++)
		if (szMainForm[8][i] != '&')
	    	szBuf[j++] = szMainForm[8][i];
	szBuf[j]=0;
	AboutForm->Caption = szBuf;

	strcpy(szBuf, szMainForm[48]);
    strcat(szBuf, " :");
	AboutForm->LbVersion->Caption = szBuf;
	strcpy(szBuf, szMainForm[49]);
    strcat(szBuf, " :");
	AboutForm->LbEmail->Caption = szBuf;
	strcpy(szBuf, szMainForm[50]);
    strcat(szBuf, " :");
	AboutForm->LbWeb->Caption = szBuf;
	AboutForm->ShowModal ();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::CloseBtnClick(TObject *Sender)
{
	ClearList();
	Close();
}

//---------------------------------------------------------------------------

// Options button

void __fastcall TMainForm::OptionsBtnClick(TObject *Sender)
{
	int	n;

	OptionsForm->Left = MainForm->Left+45;
	OptionsForm->Top = MainForm->Top+120;
    OptionsForm->InitCombo();	// Because column settings may have changed
	OptionsForm->ShowModal ();

	// We clear the list & update it with the colums chosen in Options

	n = LV->Items->Count;
	if (n)
	{
        if (LV->Selected)
			ligIndex = LV->Selected->Index;
		LV->Selected = NULL;

		while (--n >= 0)
		{
			TTntListItem *p = LV->Items->Item[n];
			p->SubItems->Clear ();
			pai = (FileInfo *)p->Data;
			LVInsert(Sender, p);
		}
        if (ligIndex != -1)
			LV->Items->Item[ligIndex]->Selected = true;
	}
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::FormResize(TObject *Sender)
{
	if (ClientWidth < 632)	ClientWidth = 632;
	if (ClientHeight < 220)	ClientHeight = 220;
	PC->Width = ClientWidth;
	PC->Height = ClientHeight;
	LV->Width = ClientWidth - 24;
	LV->Height = ClientHeight - 162;

	FDetails->Width = ClientWidth - 64;
	FDetails->Top = ClientHeight - 94;
	FWebBtn->Left = ClientWidth - 52;
	FWebBtn->Top = ClientHeight - 93;

	VDetails->Width = ClientWidth - 64;
	VDetails->Top = ClientHeight - 74;
	VWebBtn->Left = ClientWidth - 52;
	VWebBtn->Top = ClientHeight - 73;

	ADetails->Width = ClientWidth - 64;
	ADetails->Top = ClientHeight - 54;
	AWebBtn->Left = ClientWidth - 52;
	AWebBtn->Top = ClientHeight - 53;

	LVvc->Width = ClientWidth - 24;
	LVvc->Height = ClientHeight - 68;
}

//---------------------------------------------------------------------------
// 2006-07-26 : replaced link to player by link to codec pack

void __fastcall TMainForm::FWebBtnClick(TObject *Sender)
{
//	int result =(int)ShellExecute (0, "open", pai->szFileUrl, "", "", SW_SHOWNORMAL);
	int result =(int)ShellExecute (0, "open", "http://www.yatoshi.com/", "", "", SW_SHOWNORMAL);
	if (result <= 32)
		if (!bOptions[OPT_Silent])
			ShowMessage (szErrorString[3]);
}

void __fastcall TMainForm::VWebBtnClick(TObject *Sender)
{
	int result =(int)ShellExecute (0, "open", pai->szVCurl, "", "", SW_SHOWNORMAL);
	if (result <= 32)
		if (!bOptions[OPT_Silent])
			ShowMessage (szErrorString[3]);
}

void __fastcall TMainForm::AWebBtnClick(TObject *Sender)
{
	int result =(int)ShellExecute (0, "open", pai->a[0].szACurl, "", "", SW_SHOWNORMAL);
	if (result <= 32)
		if (!bOptions[OPT_Silent])
			ShowMessage (szErrorString[3]);
}

// Export of all detail from Multimedia files
//---------------------------------------------------------------------------

void __fastcall TMainForm::ExpFileListBtnClick(TObject *Sender)
{
	int		c, i, j, n;
	FILE	*fh;
    char	szBuf[1024];


	SaveDialog1->FileName = szMainForm[53];
	if (Sender != NULL)				// If not mode "analyze / export / quit"
		if (!SaveDialog1->Execute())
			return;

	if (bWin9x)	//	The operating system is Windows NT 4.0, Windows Me, Windows 98, or Windows 95.
	    	fh = fopen (((AnsiString)SaveDialog1->FileName).c_str(), "wt");
	// Use of _wfopen() instead of fopen() to allow Unicode filename
    else	fh = _wfopen (SaveDialog1->FileName, L"wt");
    if (fh == NULL)
    	return;

	if (bOptions[OPT_ExpCol])
	{
		strcpy(szBuf, "");
		for (i=0 ; i<NBCOL ; i++)
		{
			c = colId[i];
			if (c == -1)
				continue;
			strcat(szBuf, "\"");
			strcat(szBuf, col[c].szColName);
			strcat(szBuf, "\";");
        }
    }
    else
		strcpy(szBuf, szOtherString[9]);
	strcat(szBuf, "\n");
	fputs (szBuf, fh);

	n = LV->Items->Count;
	for (i=0 ; i<n ; i++)
    {
		TTntListItem *p = LV->Items->Item[i];
		pai = (struct FileInfo *)p->Data;

		if (bOptions[OPT_ExpCol])
        {
			strcpy(szBuf, ((AnsiString)p->Caption).c_str());
            strcat(szBuf, ";");
			for (j=1 ; j<NBCOL ; j++)
			{
				c = colId[j];
				if (c == -1)
					continue;
	            strcat(szBuf, "\"");
        		GetColData(c, szBuf+strlen(szBuf));
	            strcat(szBuf, "\";");
			}
            strcat(szBuf, "\n");
        }
        else
		 wsprintf (szBuf, "%s;%s;%s;%s;%d;%d;%d;%d;%s;%s;\"%s\";%s;%s;%d;\"%s\";%d;%d;%d;%d.%d;%d;%d;%d;%d;%04x;\"%s\";%s;%d;%d;%d;%d;%d;%d;%d;%04x;\"%s\";%s;%d;%d;%d;%d;%d;%d;%d\n",
        	((AnsiString)p->Caption).c_str(),
			pai->szFileType,
			pai->szFileDate,
			pai->szFileInfo,
			pai->dwFileRealSize,
			pai->dwFileTheoSize,
			pai->dwFileDuration,
			pai->wFileQuality,
			pai->bDRMlocked ? "DRM" : "",
			pai->szVC,
			pai->szVCname,
			pai->szVCurl,
			pai->szVCdriver,
			pai->wVCsupp,
			pai->szAspRatio,
			pai->dwWidth,
			pai->dwHeight,
			pai->dwFramesNb,
			pai->dwFps/1000,
			pai->dwFps%1000,
			pai->dwVSec,
			pai->dwVSize,
			pai->dwVAvgBPS*8/1000,
			pai->wAStreamsNb,
			pai->a[0].wAC,
			pai->a[0].szACname,
			pai->a[0].szACurl,
			pai->a[0].wACsupp,
			pai->a[0].wAChannels,
			pai->a[0].dwASnb,
			pai->a[0].dwASps,
			pai->a[0].dwAAvgBPS*8/1000,
			pai->a[0].dwASec,
			pai->a[0].dwASize,
			pai->a[1].wAC,
			pai->a[1].szACname,
			pai->a[1].szACurl,
			pai->a[1].wACsupp,
			pai->a[1].wAChannels,
			pai->a[1].dwASnb,
			pai->a[1].dwASps,
			pai->a[1].dwAAvgBPS*8/1000,
			pai->a[1].dwASec,
			pai->a[1].dwASize
            );
		fputs (szBuf, fh);
    }
    fclose (fh);
}

// We accept drag & drop + Clipboard view in Main Window

void __fastcall TMainForm::FormCreate(TObject *Sender)
{
	// Allow receiving draged files (for Drag & Drop)
	DragAcceptFiles(Handle, true);

	// Put AVIcodec in the list of clipboard viewer
    hWndNextViewer = SetClipboardViewer(Handle);
}

// Handling of dropped file

MESSAGE void __fastcall TMainForm::HandleDropFiles(TMessage& Msg)
{
	wchar_t	szFile[MAXPATH];
	HDROP hDrop = (HDROP)Msg.WParam;
    int	NbFiles = DragQueryFile (hDrop, -1, NULL, 0);

    for (int i=0 ; i<NbFiles ; i++)
    {
    	DragQueryFileW (hDrop, i, szFile, MAXPATH-1);
		if (!AddFile (szFile, bOptions[OPT_SaveHeader]))
	        LV->Items->Item[0]->Selected = true;
	}
    DragFinish (hDrop);
}

// Handling of Clipboard content
// Because I use it to send data from new instance to the first one

MESSAGE void __fastcall TMainForm::OnDrawClipboard(TMessage& Msg)
{
	char	szBuf[255];

	if (!hWndNextViewer)	// Should not happened ?
    	return;
	TClipboard	*clip=Clipboard();
    if (clip==NULL)	// Some people have problems ("Unable to open clipboard")
    	return;
	if (clip->HasFormat(CF_TEXT))
    {
		clip->GetTextBuf(szBuf, 255);
		if (!strncmp(szBuf, "AVIcodec: ", 10) && (szMainForm[0] != NULL))
        {
			int	l = strlen(szBuf);
			clip->Clear();
            if (l != 10)
            {
				szBuf[l-1]='\0';	// To suppress quote around filename
				StringToWideChar((AnsiString)szBuf+11, wszInitDir, 2*MAXPATH);
				ExecCmdLine();
            }
        }
    }
	clip->Close();
}

// Allow to select an object added via commandline the 1st time

MESSAGE void __fastcall TMainForm::OnSelect(TMessage& Msg)
{
	if (LV->Items->Count)
//    {
//		LV->Items->Item[0]->Selected = false;
//		LV->Items->Item[0]->Focused = true;
		LV->Items->Item[0]->Selected = true;
//        LV->ItemFocused = LV->Items->Item[0];
//    }
}

// If 'Scan recursively' is checked, then I check also 'Scan directory'

//---------------------------------------------------------------------------
// SECTION "PAGE VIDEO & PAGE AUDIO UPDATE
//---------------------------------------------------------------------------

SystemInfo *pSI;

void __fastcall TMainForm::LVvcInsert(TObject *Sender, TListItem *Item)
{
	Item->SubItems->Add (ci.bDisabled ? szMainForm[60] : szMainForm[59]);
	Item->SubItems->Add (ci.szName);
	Item->SubItems->Add (ci.szVers);
	Item->SubItems->Add (ci.szComp);
	Item->SubItems->Add (ci.szFile);
}

//---------------------------------------------------------------------------
// Page change -> Codec page management
//---------------------------------------------------------------------------

int		vcSortedColumn;
bool	vcAscDescSort[NBCOL];

void __fastcall TMainForm::LVvcColumnClick(TObject *Sender, TListColumn *Column)
{
	vcSortedColumn = Column->Index;
	vcAscDescSort[vcSortedColumn] = !vcAscDescSort[vcSortedColumn];
	LVvc->AlphaSort();
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::LVvcCompare(TObject *Sender, TListItem *Item1,
	  TListItem *Item2, int Data, int &Compare)
{
	switch (vcSortedColumn)
	{
	case 0 :
		Compare = Item1->Caption.AnsiCompare(Item2->Caption);
		break;
	default :
		Compare = Item1->SubItems->Strings[vcSortedColumn-1].AnsiCompare(Item2->SubItems->Strings[vcSortedColumn-1]);
	}
	if (vcAscDescSort[vcSortedColumn]) Compare = -Compare;
}

int vcPage;	// Contains the current "video-codec" page
enum { VCP_Video=0, VCP_Audio, VCP_Dshow, VCP_Dmo };

void __fastcall TMainForm::PCChange(TObject *Sender)
{
	if (PC->ActivePage == PageCodecs)
	{
		BOOL	bVideo = RBvideo->Checked;
		BOOL	bAudio = RBaudio->Checked;
		BOOL	bDshow = RBdsf->Checked;
		UINT	max;

		LVvc->Items->Clear ();			// Clear the list
		if (bOptions[OPT_DisableDMO])
        	RBdmo->Enabled = false;

		pSI = new SystemInfo;
		if (bVideo)
        {	max = pSI->getVCcount (); vcPage = VCP_Video;	}
        else if (bAudio)
        {	max = pSI->getACcount (); vcPage = VCP_Audio;	}
        else if (bDshow)
        {	max = pSI->getDScount (); vcPage = VCP_Dshow;	}
		else
        {	max = pSI->getDMOcount (); vcPage = VCP_Dmo;	}

		// I add a popup menu for DirectShow filters
        LVvc->PopupMenu = (bAudio ? NULL : PopupMenuCF);

		for (UINT i=0 ; i<max ; i++)
        {
			if (bVideo)
					pSI->getVC (i);
			else if (bAudio)
					pSI->getAC (i);
			else if (bDshow)
					pSI->getDS (i);
			else	pSI->getDMO (i);
			TListItem *pLI = MainForm->LVvc->Items->Add();
			pLI->Caption = ci.szId;
            pLI->Data = (void *)ci.bDisabled;
		}
		delete (pSI);

		// Sorted column is the first for audio & vido, the third to DShow & DMO
		vcSortedColumn = (!bVideo && !bAudio ? 2 : 0);
		vcAscDescSort[vcSortedColumn] = 0;
		LVvc->AlphaSort();
	}
}

// Export the content of ListBox
//---------------------------------------------------------------------------

void __fastcall TMainForm::ExpVCListBtnClick(TObject *Sender)
{
	int		i, n;
	FILE	*fh;
    char	szBuf[1024];
    char	szFile[MAXPATH];

	if (RBvideo->Checked)
			strcpy (szFile, szMainForm[54]);
	else if (RBaudio->Checked)
			strcpy (szFile, szMainForm[55]);
	else if (RBdsf->Checked)
			strcpy (szFile, szMainForm[56]);
    else	strcpy (szFile, szMainForm[57]);

	SaveDialog1->FileName = szFile;
	if (!SaveDialog1->Execute())
		return;

	if (bWin9x)
	    	fh = fopen (((AnsiString)SaveDialog1->FileName).c_str(), "wt");
    else	fh = _wfopen (SaveDialog1->FileName, L"wt");
	if (fh == NULL)
    	return;

	n = LVvc->Items->Count;
	for (i=0 ; i<n ; i++)
    {
		TListItem *p = LVvc->Items->Item[i];
		wsprintf (szBuf, "%s;%s;%s;%s;%s;%s\n",
        	p->Caption.c_str(),
			p->SubItems->Strings[0].c_str(),
            p->SubItems->Strings[1].c_str(),
            p->SubItems->Strings[2].c_str(),
            p->SubItems->Strings[3].c_str(),
            p->SubItems->Strings[4].c_str());
		fputs (szBuf, fh);
    }
    fclose (fh);
}

// Load / Save parameters
//---------------------------------------------------------------------------

bool __fastcall TMainForm::LoadParam ()
{
	HKEY	hkey;
	DWORD	dwSize=256;
    TCHAR	data[256];
	char	szBuf[255];
    int	rc;
    bool	bInstalled;

	GetCurrentDirectory(MAXPATH-1, szInstallDir);
	wcscpy (wszInitDir, L"");
	strcpy (szLang, "");
    strcpy (szFontName, "MS Sans Serif");
	colId[0] = FNAM;
	colId[1] = VCON;
	colId[2] = A1CON;
	colId[3] = FINF;
	for(int i=4 ; i<NBCOL ; i++)
		colId[i] = -1;

	rc = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\AVIcodec", 0, KEY_READ, &hkey);
	if (rc == ERROR_SUCCESS)
	{
		rc = RegQueryValueEx(hkey, "", NULL, NULL, data, &dwSize);
		if (!rc)	strcpy(szInstallDir, data);
		dwSize=256;
		rc = RegQueryValueExW(hkey, L"szInitDir", NULL, NULL, data, &dwSize);
		if (!rc)	memcpy (wszInitDir, data, dwSize);
        bInstalled = !rc;	// Because it is empty only the 1st time
		dwSize=256;
		rc = RegQueryValueEx(hkey, "szLang", NULL, NULL, data, &dwSize);
		if (!rc)	strcpy (szLang, data);
		dwSize=256;
		rc = RegQueryValueEx(hkey, "szFontName", NULL, NULL, data, &dwSize);
		if (!rc)	strcpy (szFontName, data);

		dwSize=256;
		rc = RegQueryValueEx(hkey, "ChScanRec", NULL, NULL, data, &dwSize);
		if (!rc)	bOptions[OPT_ScanRec] = *(DWORD *)data;
        ChScanRec->Checked = bOptions[OPT_ScanRec];
		dwSize=256;
		rc = RegQueryValueEx(hkey, "ChSaveHeader", NULL, NULL, data, &dwSize);
		if (!rc)	bOptions[OPT_SaveHeader] = *(DWORD *)data;
        ChSaveHeader->Checked = bOptions[OPT_SaveHeader];
		dwSize=256;
		rc = RegQueryValueEx(hkey, "ChClearList", NULL, NULL, data, &dwSize);
		if (!rc)	bOptions[OPT_ClearList] = *(DWORD *)data;
       	ChClearList->Checked = bOptions[OPT_ClearList];
		dwSize=256;
		rc = RegQueryValueEx(hkey, "ChHidePath", NULL, NULL, data, &dwSize);
		if (!rc)	bOptions[OPT_HidePath] = *(DWORD *)data;
       	ChHidePath->Checked = bOptions[OPT_HidePath];
		dwSize=256;
		rc = RegQueryValueEx(hkey, "ChSilent", NULL, NULL, data, &dwSize);
		if (!rc)	bOptions[OPT_Silent] = *(DWORD *)data;
		ChSilent->Checked = bOptions[OPT_Silent];
		dwSize=256;
		rc = RegQueryValueEx(hkey, "ChFastScan", NULL, NULL, data, &dwSize);
		if (!rc)	bOptions[OPT_FastScan] = *(DWORD *)data;
        ChFastScan->Checked = bOptions[OPT_FastScan];
		dwSize=256;
		rc = RegQueryValueEx(hkey, "ChDisableDMO", NULL, NULL, data, &dwSize);
		if (!rc)	bOptions[OPT_DisableDMO] = *(DWORD *)data;
		dwSize=256;
		rc = RegQueryValueEx(hkey, "ChAssocFiles", NULL, NULL, data, &dwSize);
		if (!rc)	bOptions[OPT_AssocFiles] = *(DWORD *)data;
		dwSize=256;
		rc = RegQueryValueEx(hkey, "ChAssocDir", NULL, NULL, data, &dwSize);
		if (!rc)	bOptions[OPT_AssocDir] = *(DWORD *)data;
		dwSize=256;
		rc = RegQueryValueEx(hkey, "ChExpCol", NULL, NULL, data, &dwSize);
		if (!rc)	bOptions[OPT_ExpCol] = *(DWORD *)data;

		for (int i=0 ; i<NBCOL ; i++)
    	{
			dwSize=256;
			wsprintf(szBuf, "colId%d", i);
			rc = RegQueryValueEx(hkey, szBuf, NULL, NULL, data, &dwSize);
			if (!rc)	colId[i] = *(DWORD *)data;

			// Restore column width

			dwSize=256;
			wsprintf(szBuf, "colWidth%d", i);
			rc = RegQueryValueEx(hkey, szBuf, NULL, NULL, data, &dwSize);
			if (!rc && (colId[i] >= 0))
            	LV->Columns->Items[i]->Width = *(DWORD *)data;
		}

		dwSize=256;
		rc = RegQueryValueEx(hkey, "WindowLeft", NULL, NULL, data, &dwSize);
		if (!rc)	MainForm->Left = *(DWORD *)data;
		dwSize=256;
		rc = RegQueryValueEx(hkey, "WindowTop", NULL, NULL, data, &dwSize);
		if (!rc)	MainForm->Top = *(DWORD *)data;
		dwSize=256;
		rc = RegQueryValueEx(hkey, "WindowWidth", NULL, NULL, data, &dwSize);
		if (!rc)	MainForm->Width = *(DWORD *)data;
		dwSize=256;
		rc = RegQueryValueEx(hkey, "WindowHeight", NULL, NULL, data, &dwSize);
		if (!rc)	MainForm->Height = *(DWORD *)data;
        rc = ERROR_SUCCESS;
	}
	RegCloseKey(hkey);
    return bInstalled;
}

void __fastcall TMainForm::SaveParam ()
{
	HKEY	hkey;
    TCHAR	data[256];
	int 	rc = 0;
	char	szBuf[255];

	rc = RegOpenKeyEx(HKEY_LOCAL_MACHINE, "Software\\AVIcodec", 0, KEY_SET_VALUE, &hkey);
	if (rc == ERROR_SUCCESS)
    {
		rc = RegSetValueExW(hkey, L"szInitDir", NULL, REG_SZ, (BYTE *)wszInitDir, 2*wcslen(wszInitDir)+1);
		rc = RegSetValueEx(hkey, "szLang", NULL, REG_SZ, szLang, lstrlen(szLang)+1);
		rc = RegSetValueEx(hkey, "szFontName", NULL, REG_SZ, szFontName, lstrlen(szFontName)+1);

		*(DWORD *)data = (DWORD)bOptions[OPT_ScanRec];
		rc = RegSetValueEx(hkey, "ChScanRec", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)bOptions[OPT_SaveHeader];
		rc = RegSetValueEx(hkey, "ChSaveHeader", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)bOptions[OPT_ClearList];
		rc = RegSetValueEx(hkey, "ChClearList", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)bOptions[OPT_Silent];
		rc = RegSetValueEx(hkey, "ChSilent", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)bOptions[OPT_HidePath];
		rc = RegSetValueEx(hkey, "ChHidePath", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)bOptions[OPT_DisableDMO];
		rc = RegSetValueEx(hkey, "ChDisableDMO", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)bOptions[OPT_FastScan];
		rc = RegSetValueEx(hkey, "ChFastScan", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)bOptions[OPT_AssocFiles];
		rc = RegSetValueEx(hkey, "ChAssocFiles", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)bOptions[OPT_AssocDir];
		rc = RegSetValueEx(hkey, "ChAssocDir", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)bOptions[OPT_ExpCol];
		rc = RegSetValueEx(hkey, "ChExpCol", NULL, REG_DWORD, data, sizeof(DWORD));

		for (int i=0 ; i<NBCOL ; i++)
    	{
			wsprintf(szBuf, "colId%d", i);
			*(DWORD *)data = (DWORD)colId[i];
			rc = RegSetValueEx(hkey, szBuf, NULL, REG_DWORD, data, sizeof(DWORD));

			wsprintf(szBuf, "colWidth%d", i);
			*(DWORD *)data = (DWORD)LV->Columns->Items[i]->Width;
			rc = RegSetValueEx(hkey, szBuf, NULL, REG_DWORD, data, sizeof(DWORD));
		}

		*(DWORD *)data = (DWORD)MainForm->Left;
		rc = RegSetValueEx(hkey, "WindowLeft", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)MainForm->Top;
		rc = RegSetValueEx(hkey, "WindowTop", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)MainForm->Width;
		rc = RegSetValueEx(hkey, "WindowWidth", NULL, REG_DWORD, data, sizeof(DWORD));
		*(DWORD *)data = (DWORD)MainForm->Height;
		rc = RegSetValueEx(hkey, "WindowHeight", NULL, REG_DWORD, data, sizeof(DWORD));

		rc = RegCloseKey(hkey);
	}
}

// Load language texts
//---------------------------------------------------------------------------

#define MAXITBUF    500

char *szErrorString[30];				// Error strings
char *szOtherString[30];				// Other strings
char *szMainForm[70];					// Main strings
char *szOptionsForm[20];				// OptionsForm
extern struct ASPECTRATIO ara[MAXARA];

int __fastcall TMainForm::InitText ()
{
    char    szBuf[MAXITBUF],
    		szFile[MAXPATH], *p;
    int		table, idx, len;
	FILE	*fh;

	wsprintf (szFile, "%s\\lang\\%s.txt", szInstallDir, szLang);
	fh = fopen (szFile, "rt");
	if (fh == NULL)	// If I don't find the language file, I try english one
	{
		wsprintf (szFile, "%s\\lang\\English.txt", szInstallDir);
		fh = fopen (szFile, "rt");
		if (fh == NULL)
		{
    		strcpy (szErr, "Error on opening language file");
        	return -1;
        }
    }

	table = 0;
	while (fgets (szBuf, MAXITBUF, fh))
    {
		if ((*szBuf==';') || (*szBuf=='\n'))  // Comment or newline
            continue;
		len = strlen (szBuf);
		szBuf[len-1] = 0;	// We delete last character (\n)
        if (!strcmp (szBuf, "<Column name>"))
        {	table = 1; idx = 0;	continue; }
        if (!strcmp (szBuf, "<Error strings>"))
        {	table = 2; idx = 0;	continue; }
        if (!strcmp (szBuf, "<Other strings>"))
        {	table = 3; idx = 0;	continue; }
        if (!strcmp (szBuf, "<MainForm>"))
        {	table = 4; idx = 0;	continue; }
        if (!strcmp (szBuf, "<OptionsForm>"))
        {	table = 5; idx = 0;	continue; }

		// Storage in corresponding table
		if (!table)	continue;
		p = new char [len];
		strcpy (p, szBuf);
		switch (table)
        {
		case 1: col[idx++].szColName = p; break;
		case 2:	szErrorString[idx++] = p; break;
		case 3: szOtherString[idx++] = p; break;
		case 4: szMainForm[idx++] = p; break;
		case 5: szOptionsForm[idx++] = p; break;
        }
    }
	fclose (fh);

	strcpy (ara[3].szAra, szOtherString[11]);

	PageAVI->Caption = szMainForm[0];
	PageAVI->Hint = szMainForm[1];
	PageCodecs->Caption = szMainForm[2];
	PageCodecs->Hint = szMainForm[3];
	SelFileBtn->Caption = szMainForm[4];
	SelFileBtn->Hint = szMainForm[5];
	OpenDialog1->Title = szMainForm[5];
	OptionsBtn->Caption = szMainForm[6];
	OptionsBtn->Hint = szMainForm[7];
	AboutBtn->Caption = szMainForm[8];
	AboutBtn->Hint = szMainForm[9];
	ExpFileListBtn->Caption = szMainForm[10];
	ExpFileListBtn->Hint = szMainForm[11];
	CloseBtn->Caption = szMainForm[12];
	CloseBtn->Hint = szMainForm[13];
//	ChScanDir->Caption = szMainForm[14];
//	ChScanDir->Hint = szMainForm[15];
	ChScanRec->Caption = szMainForm[16];
	ChScanRec->Hint = szMainForm[17];
	ChSaveHeader->Caption = szMainForm[18];
	ChSaveHeader->Hint = szMainForm[19];
	ChClearList->Caption = szMainForm[20];
	ChClearList->Hint = szMainForm[21];
//	ChSilent->Caption = szMainForm[22];
//	ChSilent->Hint = szMainForm[23];
	ChSilent->Caption = szOptionsForm[5];
	ChSilent->Hint = szOptionsForm[6];
	ChHidePath->Caption = szMainForm[24];
	ChHidePath->Hint = szMainForm[25];
	FDetails->Text = szMainForm[26];
	VDetails->Text = szMainForm[27];
	ADetails->Text = szMainForm[28];
	RBvideo->Caption = szMainForm[29];
	RBvideo->Hint = szMainForm[30];
	RBaudio->Caption = szMainForm[31];
	RBaudio->Hint = szMainForm[32];
	RBdsf->Caption = szMainForm[33];
	RBdsf->Hint = szMainForm[34];
	ExpVCListBtn->Caption = szMainForm[10];
	ExpVCListBtn->Hint = szMainForm[11];
	for (int i=0 ; i<6 ; i++)
	    LVvc->Columns->Items[i]->Caption = szMainForm[35+i];
	SelDirBtn->Caption = szMainForm[41];
	SelDirBtn->Hint = szMainForm[42];
	FDetails->Hint = szMainForm[43];
	VDetails->Hint = szMainForm[44];
	ADetails->Hint = szMainForm[45];
	FWebBtn->Caption = szMainForm[50];
	VWebBtn->Caption = szMainForm[50];
	AWebBtn->Caption = szMainForm[50];
	strcpy(szBuf, szMainForm[50]);

	RBdmo->Caption = szMainForm[46];
	RBdmo->Hint = szMainForm[47];
	ChFastScan->Caption = szMainForm[51];
	ChFastScan->Hint = szMainForm[52];
    PopupMenuCF->Items->Items[0]->Caption = szMainForm[62];
    PopupMenuCF->Items->Items[1]->Caption = szMainForm[61];
    PopupMenuFL->Items->Items[0]->Caption = szMainForm[63];

	LV->Font->Name = szFontName;	// Setup of Police for movie list (pb with Unicode with MS Sans Serif)

    return 0;
}
//---------------------------------------------------------------------------

char * __fastcall TMainForm::szSize (DWORD size, int unit, int pos)
{
	static char szTmp[50];
    DWORD	val=size, reste=0;

	while (val > 1024)
	{	reste = val & 0x03FF; val >>= 10; unit++;	}	// /1024
	if (val < 20)
			wsprintf (szTmp+pos, "%d.%02d %s", val, (reste*100)>>10, !unit ? szOtherString[16] : unit==1 ? szOtherString[17] : unit==2 ? szOtherString[18] : szOtherString[19]);
	else	wsprintf (szTmp+pos, "%d %s", val, !unit ? szOtherString[16] : unit==1 ? szOtherString[17] : unit==2 ? szOtherString[18] : szOtherString[19]);
	return szTmp+pos;
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::ChClearListClick(TObject *Sender)
{
	bOptions[OPT_ClearList] = ChClearList->Checked;
}
void __fastcall TMainForm::ChScanRecClick(TObject *Sender)
{
	bOptions[OPT_ScanRec] = ChScanRec->Checked;
}
void __fastcall TMainForm::ChHidePathClick(TObject *Sender)
{
	bOptions[OPT_HidePath] = ChHidePath->Checked;
}
void __fastcall TMainForm::ChSaveHeaderClick(TObject *Sender)
{
	bOptions[OPT_SaveHeader] = ChSaveHeader->Checked;
}
void __fastcall TMainForm::ChFastScanClick(TObject *Sender)
{
	bOptions[OPT_FastScan] = ChFastScan->Checked;
}

//---------------------------------------------------------------------------
// Store data in clipboard

void __fastcall TMainForm::LVKeyDown(TObject *Sender, WORD &Key, TShiftState Shift)
{
	if (!LV->Selected)	return;
	ligIndex = LV->Selected->Index;
	TTntListItem *p = LV->Items->Item[ligIndex];

	if (Key==VK_DELETE)
    {
		delete p->Data;
		p->Delete();
		if (LV->Items->Count)
        {
			if (LV->Items->Count <= ligIndex)
            	ligIndex = LV->Items->Count-1;
	        LV->Items->Item[ligIndex]->Selected = true;
        }
    }

    if (!Shift.Contains(ssCtrl))	return;

	pai = (struct FileInfo *)p->Data;
	if (!pai)	return;

	TTntClipboard	*clip=TntClipboard();	// Instance to windows Clipboard
    if (Key==(WORD)'F')				// Ctrl-F
        clip->AsWideText = p->Caption;
    else if (Key==(WORD)'V')		// Ctrl-V
        clip->AsWideText = (StringToWideChar(pai->szVCname, wszTemp, 2*MAXPATH));
    else if (Key==(WORD)'A')		// Ctrl-A
        clip->AsWideText = (StringToWideChar(pai->a[0].szACname, wszTemp, 2*MAXPATH));
//	clip->Close();
}

//---------------------------------------------------------------------------

void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	// Retire from clipboard viewer list
	if (hWndNextViewer)
		ChangeClipboardChain(Handle, hWndNextViewer);
}

//---------------------------------------------------------------------------
// Open (Unicodec) the selected file
//---------------------------------------------------------------------------

void __fastcall TMainForm::LVDblClick(TObject *Sender)
{
	if (!LV->Selected)	return;

	TTntListItem *p = LV->Items->Item[LV->Selected->Index];
	pai = (struct FileInfo *)p->Data;

//	int result =(int)ShellExecute(0, "open", ((AnsiString)p->Caption).c_str(), "", "", SW_SHOWNORMAL);
	int result =(int)ShellExecuteW(0, L"open", p->Caption, L"", L"", SW_SHOWNORMAL);
	if (result <= 32)
		if (!bOptions[OPT_Silent])
			ShowMessage (szErrorString[3]);
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ChSilentClick(TObject *Sender)
{
	bOptions[OPT_Silent] = ChSilent->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::LVColumnRightClick(TObject *Sender,
      TListColumn *Column, TPoint &Point)
{
	if (MessageBox(Handle, "Do you want to remove this column ?", "Column setting", MB_YESNO | MB_ICONQUESTION)
		    ==IDYES)
    {
		for (int i=Column->Index ; i<NBCOL-1 ; i++)
        	colId[i] = colId[i+1];
       	colId[NBCOL-1] = -1;
        InitColumns();
    }
}
//---------------------------------------------------------------------------
// Disable a DirectShow Filter by adding : to the CLSID key of the Filter enumerator
//---------------------------------------------------------------------------

void __fastcall TMainForm::DisableClick(TObject *Sender)
{
	TCHAR	szKey[512];
	HKEY	hkeyFilter = 0;
	int 	rc = 0;
    char	szBuf[200], *p;
	DWORD	dwSize, dwType;

	if (!LVvc->Selected)	return;

	TListItem *pLI = LVvc->Items->Item[LVvc->Selected->Index];
   	pLI->SubItems->Strings[0] = szMainForm[60];	// Disabled
	pLI->Data = (void *)true;
	LVvc->Selected = NULL;

	switch(vcPage)
    {
	case VCP_Video:
		// Open the CLSID key that contains information about the VFW codec
		rc = RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Drivers32\0", &hkeyFilter);
		if (rc == ERROR_SUCCESS)
	    {
			wsprintf(szKey, TEXT("vidc.%s\0"), pLI->Caption.c_str());
			szBuf[0] = ':';
			dwSize = 200;
			rc = RegQueryValueEx(hkeyFilter, szKey, 0, &dwType, szBuf+1, &dwSize);
			p = szBuf;
			if (p[1] == ':')	p++;	// If already in disabled state
			rc = RegSetValueEx(hkeyFilter, szKey, 0, REG_SZ, p, strlen(p)+1);
		}
		rc = RegCloseKey(hkeyFilter);
        break;

	case VCP_Dshow:
		// Open the key that contains information about the filter
		wsprintf(szKey, TEXT("CLSID\\{083863F1-70DE-11d0-BD40-00A0C911CE86}\\Instance\\%s\0"), pLI->Caption.c_str());
		rc = RegOpenKey(HKEY_CLASSES_ROOT, szKey, &hkeyFilter);
		if (rc == ERROR_SUCCESS)
	    {
			szBuf[0] = ':';
			strcpy(szBuf+1, pLI->Caption.c_str());
			rc = RegSetValueEx(hkeyFilter, "CLSID", 0, REG_SZ, szBuf, strlen(szBuf)+1);
		}
		rc = RegCloseKey(hkeyFilter);

	case VCP_Dmo:
		// Open the key that contains information about the filter
		wsprintf(szKey, TEXT("CLSID\\%s\0"), pLI->Caption.c_str());
		rc = RegOpenKey(HKEY_CLASSES_ROOT, szKey, &hkeyFilter);
		if (rc == ERROR_SUCCESS)
	    {
			szBuf[0] = ':';
			strcpy(szBuf+1, pLI->Caption.c_str());
			rc = RegQueryValueEx(hkeyFilter, "", 0, &dwType, szBuf+1, &dwSize);
			rc = RegSetValueEx(hkeyFilter, "", 0, REG_SZ, szBuf, strlen(szBuf)+1);
		}
		rc = RegCloseKey(hkeyFilter);
    }
}

// Enable a DirectShow Filter by removing : to the CLSID key of the Filter enumerator
//---------------------------------------------------------------------------

void __fastcall TMainForm::EnableClick(TObject *Sender)
{
	TCHAR	szKey[512];
	HKEY	hkeyFilter = 0;
	int 	rc = 0;
    char	szBuf[200];
	DWORD	dwSize=200, dwType;

	if (!LVvc->Selected)	return;

	TListItem *pLI = LVvc->Items->Item[LVvc->Selected->Index];
    pLI->SubItems->Strings[0] = szMainForm[59];	// Enabled
	pLI->Data = (void *)false;
	LVvc->Selected = NULL;

	switch(vcPage)
    {
	case VCP_Video:
		// Open the key that contains information about the VFW codec
		rc = RegOpenKey(HKEY_LOCAL_MACHINE, "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion\\Drivers32\0", &hkeyFilter);
		if (rc == ERROR_SUCCESS)
	    {
			wsprintf(szKey, TEXT("vidc.%s\0"), pLI->Caption.c_str());
			rc = RegQueryValueEx(hkeyFilter, szKey, 0, &dwType, szBuf, &dwSize);
			rc = RegSetValueEx(hkeyFilter, szKey, 0, REG_SZ, szBuf+(*szBuf==':'), strlen(szBuf)-(*szBuf==':'));
		}
		rc = RegCloseKey(hkeyFilter);
        break;

	case VCP_Dshow:
		// Open the CLSID key that contains information about the filter
		strcpy(szBuf, pLI->Caption.c_str());
		wsprintf(szKey, TEXT("CLSID\\{083863F1-70DE-11d0-BD40-00A0C911CE86}\\Instance\\%s\0"), szBuf);
		rc = RegOpenKey(HKEY_CLASSES_ROOT, szKey, &hkeyFilter);
		if (rc == ERROR_SUCCESS)
			rc = RegSetValueEx(hkeyFilter, "CLSID", 0, REG_SZ, szBuf, strlen(szBuf)+1);
		rc = RegCloseKey(hkeyFilter);

	case VCP_Dmo:
		// Open the CLSID key that contains information about the filter
		wsprintf(szKey, TEXT("CLSID\\%s\0"), pLI->Caption.c_str());
		rc = RegOpenKey(HKEY_CLASSES_ROOT, szKey, &hkeyFilter);
		if (rc == ERROR_SUCCESS)
        {
			rc = RegQueryValueEx(hkeyFilter, "", 0, &dwType, szBuf, &dwSize);
			rc = RegSetValueEx(hkeyFilter, "", 0, REG_SZ, szBuf+(*szBuf==':'), strlen(szBuf)-(*szBuf==':'));
		}
		rc = RegCloseKey(hkeyFilter);
    }
}

//---------------------------------------------------------------------------
// Change the state of the PopupMenu
// according to the current state of the line

void __fastcall TMainForm::LVvcChange(TObject *Sender, TListItem *Item,
      TItemChange Change)
{
	if (Change != ctState)
    	return;
	if (Item->Selected)
	{
		bool bDisabled = (bool)Item->Data;
    	PopupMenuCF->Items->Items[0]->Enabled = !bDisabled;
    	PopupMenuCF->Items->Items[1]->Enabled = bDisabled;
    }
}
//---------------------------------------------------------------------------

// Copy File + Video + Audio data inb the clipboard

void __fastcall TMainForm::CopyinfotoclipboardClick(TObject *Sender)
{
	char	szBuf[1000];

	if (!LV->Selected)	return;

	TTntListItem *p = LV->Items->Item[LV->Selected->Index];
//	pai = (struct FileInfo *)p->Data;

	TClipboard	*clip=Clipboard();
    if (clip==NULL)	// Some people have problems ("Unable to open clipboard")
    	return;

	wsprintf(szBuf, "%ls\r\n\r\n%s\r\n%s\r\n", p->Caption, FDetails->Text, VDetails->Text);
	for (int as=0 ; as<pai->wAStreamsNb ; as++)
    {
		strcat(szBuf, ADetails->Items->Strings[as].c_str());  //  TCOmboBox
		strcat(szBuf, "\r\n");
    }
	clip->SetTextBuf(szBuf);
}

//---------------------------------------------------------------------------

