//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <Buttons.hpp>
#include <ImgList.hpp>

#include <dir.h>						// MAXPATH

#include "TntClipBrd.hpp"
#include "TntComCtrls.hpp"
#include "TntDialogs.hpp"
#include "TntStdCtrls.hpp"

//---------------------------------------------------------------------------
#define NBCOL	9
#define WM_AC_SELECT	(WM_USER + 0)
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:	// Composants grs par l'EDI
	TTntOpenDialog *OpenDialog1;
	TTntSaveDialog *SaveDialog1;
	TTntListView *LV;
	TImageList *ImageList1;
	TPageControl *PC;
	TTabSheet *PageAVI;
	TTabSheet *PageCodecs;
	TBitBtn *AboutBtn;
	TBitBtn *CloseBtn;
	TCheckBox *ChScanRec;
	TListView *LVvc;
	TBitBtn *OptionsBtn;
	TCheckBox *ChSaveHeader;
	TEdit *FDetails;
	TEdit *VDetails;
	TBitBtn *SelFileBtn;
	TCheckBox *ChClearList;
	TButton *VWebBtn;
	TButton *AWebBtn;
	TBitBtn *ExpFileListBtn;
	TBitBtn *ExpVCListBtn;
	TButton *FWebBtn;
	TComboBox *ADetails;
	TGroupBox *GroupBox1;
	TRadioButton *RBvideo;
	TRadioButton *RBaudio;
	TRadioButton *RBdsf;
	TCheckBox *ChHidePath;
	TRadioButton *RBdmo;
	TBitBtn *SelDirBtn;
	TCheckBox *ChFastScan;
	TCheckBox *ChSilent;
	TPopupMenu *PopupMenuCF;
	TMenuItem *Disable;
	TMenuItem *Enable;
	TPopupMenu *PopupMenuFL;
	TMenuItem *Copyinfotoclipboard;
	void __fastcall ExecCmdLine();
	void __fastcall SelFileBtnClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall LVInsert(TObject *Sender, TListItem *Item);
	void __fastcall LVChange(TObject *Sender, TListItem *Item, TItemChange Change);
	void __fastcall LVColumnClick(TObject *Sender, TListColumn *Column);
	void __fastcall LVCompare(TObject *Sender, TListItem *Item1, TListItem *Item2, int Data, int &Compare);
	void __fastcall LVKeyDown(TObject *Sender, WORD &Key, TShiftState Shift);

	void __fastcall AboutBtnClick(TObject *Sender);
	void __fastcall CloseBtnClick(TObject *Sender);
	void __fastcall OptionsBtnClick(TObject *Sender);
	void __fastcall PCChange(TObject *Sender);

	void __fastcall FormResize(TObject *Sender);
	void __fastcall FWebBtnClick(TObject *Sender);
	void __fastcall VWebBtnClick(TObject *Sender);
	void __fastcall AWebBtnClick(TObject *Sender);
	void __fastcall ExpVCListBtnClick(TObject *Sender);
	void __fastcall ExpFileListBtnClick(TObject *Sender);

	void __fastcall LVvcInsert(TObject *Sender, TListItem *Item);
	void __fastcall LVvcColumnClick(TObject *Sender, TListColumn *Column);
	void __fastcall LVvcCompare(TObject *Sender, TListItem *Item1,
          TListItem *Item2, int Data, int &Compare);

	void __fastcall FormCreate(TObject *Sender);
	void __fastcall ChScanRecClick(TObject *Sender);
	void __fastcall SelDirBtnClick(TObject *Sender);
	void __fastcall ChClearListClick(TObject *Sender);
	void __fastcall ChHidePathClick(TObject *Sender);
	void __fastcall ChSaveHeaderClick(TObject *Sender);
	void __fastcall ChFastScanClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall LVDblClick(TObject *Sender);
	void __fastcall ChSilentClick(TObject *Sender);
    void __fastcall GetColData(int col, char *p);
	void __fastcall LVColumnRightClick(TObject *Sender, TListColumn *Column,
          TPoint &Point);
	void __fastcall DisableClick(TObject *Sender);
	void __fastcall EnableClick(TObject *Sender);
	void __fastcall LVvcChange(TObject *Sender, TListItem *Item,
          TItemChange Change);
	void __fastcall CopyinfotoclipboardClick(TObject *Sender);

private:	// Dclarations de l'utilisateur
	MESSAGE void __fastcall HandleDropFiles(TMessage&);
    MESSAGE void __fastcall OnDrawClipboard(TMessage&);
    MESSAGE void __fastcall OnSelect(TMessage&);
    BEGIN_MESSAGE_MAP
    	MESSAGE_HANDLER(WM_DROPFILES, TMessage, HandleDropFiles);
    	MESSAGE_HANDLER(WM_DRAWCLIPBOARD, TMessage, OnDrawClipboard);
    	MESSAGE_HANDLER(WM_AC_SELECT, TMessage, OnSelect);
    END_MESSAGE_MAP(TForm);
	void __fastcall ClearList ();
	int __fastcall AddFile (wchar_t *wszFile, BOOL bSaveHeader);
	void __fastcall ScanDir (wchar_t *wszPath, BOOL recursive, BOOL bSaveHeader);
	void __fastcall ExpList (char *szFile, TListView *ListView);
	void __fastcall SaveParam ();
	bool __fastcall LoadParam ();
	char * __fastcall szSize (DWORD size, int unit=0, int pos=0);
	__fastcall ~TMainForm();
public:		// Dclarations de l'utilisateur

	int		colId[NBCOL];					// Id of information in columns
    wchar_t	wszInitDir[2*MAXPATH];
    wchar_t	wszTemp[2*MAXPATH];
    char	szInstallDir[MAXPATH];
    char	szLang[20];
    char	szFontName[100];
    int		ligIndex;
    bool	bWin9x;						// Is Win 9x ?

	__fastcall TMainForm(TComponent* Owner);
	int __fastcall InitText ();
	void __fastcall InitColumns (bool bOnlyCaption);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------

// Columns that can be diplayed in the ListBox

#define MAXCOL	38
enum { FNAM=0, VFCC, VCON, VCOS, VRES, VRAT, VFRN, VFRQ, VTIM, VARA, VSIZ, ASTR, ATSZ, A1COI, A1CON, A1COS, A1TIM, A1CHA, A1SNB, A1FRQ, A1RAT, A1SIZ, A2COI, A2CON, A2COS, A2TIM, A2CHA, A2SNB, A2FRQ, A2RAT, A2SIZ, FTYP, FRSZ, FTSZ, FQUA, FDAT, FDRM, FINF };
struct COLUMN
{
	char	iNum;
	char	*szColName;
	int		iColWidth;
    char	cSortType;
};
extern struct COLUMN col[MAXCOL];
extern char *szErrorString[30];
extern char *szOtherString[30];
extern char *szMainForm[70];
extern char *szOptionsForm[20];					// OptionsForm

enum { OPT_ScanRec=0, OPT_SaveHeader, OPT_ClearList, OPT_HidePath, OPT_Silent, OPT_DisableDMO, OPT_FastScan, OPT_AssocFiles, OPT_AssocDir, OPT_ExpCol };
extern BOOL	bOptions[10];	// 10 : to be incremented for next option
//---------------------------------------------------------------------------
#endif

