//---------------------------------------------------------------------------

#ifndef MpegInfoH
#define MpegInfoH
//---------------------------------------------------------------------------

// MPEG 1 & 2 Start Code

#define MPEG_PICTURE_SC				0x00000100
#define MPEG_SLICE_MIN_START		0x00000101
#define MPEG_SLICE_MAX_START		0x000001AF
#define MPEG_USER_DATA_SC			0x000001B2
#define MPEG_SEQUENCE_SC			0x000001B3
#define MPEG_SEQUENCE_ERR_SC		0x000001B4
#define MPEG_EXT_SC					0x000001B5
#define MPEG_SEQUENCE_END_SC    	0x000001B7
#define MPEG_GOP_SC					0x000001B8
#define SYSTEM_START_CODE_MIN		0x000001B9;
#define SYSTEM_START_CODE_MAX		0x000001FF;

#define MPEG_PROGRAM_END_CODE		0x000001B9
#define MPEG_PACK_SC				0x000001BA
#define SYSTEM_HEADER_SC			0x000001BB
#define MPEG_PRIVATE_STREAM_1		0x000001BD
#define MPEG_AUDIO_C0_CODE			0x000001C0 // 1st audio stream
#define MPEG_AUDIO_C1_CODE			0x000001C1 // 2nd audio stream id (dual channel)
#define MPEG_AUDIO_C2_CODE			0x000001C2 // 3rd audio stream id (surround sound)
#define MPEG_VIDEO_E0_CODE			0x000001E0

// MPEG 2 Program Stream Start Code

#define MPEG2_PS_START      0x00000100
#define MPEG2_PS_START_MASK 0xffffff00
#define MPEG2_PS_PACKSTART  0x000001BA
#define MPEG2_PS_SYSSTART   0x000001BB
#define MPEG2_PS_END        0x000001B9

// Audio Substream code

#define SUBSTREAM_AC3_0				0x80
#define SUBSTREAM_AC3_8				0x87
#define SUBSTREAM_DTS_0				0x88
#define SUBSTREAM_DTS_8				0x8F
#define SUBSTREAM_PCM_0				0xA0
#define SUBSTREAM_PCM_F				0xAF

#define AUDIO_AC3_SYNC_WORD			0x0B77
#define AUDIO_MPEG_SYNC_WORD		0x0FFF	// 0xFFF0 if compared to AC3

extern int ParseMpeg2 (wchar_t *wszFile);

#endif
