//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <dir.h>						// findfirst

#include "options.h"
#include "Main.h"						// MAXCOL
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
//---------------------------------------------------------------------------

TOptionsForm *OptionsForm;

//---------------------------------------------------------------------------
// Functions of the TOptionsForm window
//---------------------------------------------------------------------------

// Warning : the constructor is calledduring startup of AVIcodec, and not during
// the execution of AVIcodec while clicking on Option button

__fastcall TOptionsForm::TOptionsForm(TComponent* Owner)
	: TForm(Owner)
{
	int		done;
    char	szBuf[100], *p,
			szDir[MAXPATH];
	struct	ffblk ffblk;

	// We search the different langage files

//	GetCurrentDirectory (MAXPATH, szDir);
	strcpy (szDir, MainForm->szInstallDir);
	strcat (szDir, "\\lang\\*.*");
	done = findfirst (szDir, &ffblk, FA_RDONLY | FA_ARCH);
	while (!done)
	{
		p = strrchr (ffblk.ff_name, '.');
        if (p && (strlen (p)>3))		// File with an extension
        {
			*p = 0;
			strcpy (szBuf, ffblk.ff_name);
            ComboLang->Items->Add (szBuf);
        }
		done = findnext(&ffblk);
	}
	ComboLang->SelText = MainForm->szLang;
	strcpy (szInitLang, MainForm->szLang);

	ChDisableDMO->Checked = bOptions[OPT_DisableDMO];
	ChAssocFiles->Checked = bOptions[OPT_AssocFiles];
	ChAssocDir->Checked = bOptions[OPT_AssocDir];
	ChExpCol->Checked = bOptions[OPT_ExpCol];
}

// Initialize the data linked to language

void __fastcall TOptionsForm::SetLang()
{
	int		len;
    char	szBuf[100], *p;

	Caption = szOptionsForm[0];
	len = strlen (szOptionsForm[1]);
	szOptionsForm[1][len-1] = '2';
	Label1->Caption = szOptionsForm[1];
	szOptionsForm[1][len-1] = '3';
	Label2->Caption = szOptionsForm[1];
	szOptionsForm[1][len-1] = '4';
	Label3->Caption = szOptionsForm[1];
	szOptionsForm[1][len-1] = '5';
	Label4->Caption = szOptionsForm[1];
	szOptionsForm[1][len-1] = '6';
	Label5->Caption = szOptionsForm[1];
	szOptionsForm[1][len-1] = '7';
	Label6->Caption = szOptionsForm[1];
	szOptionsForm[1][len-1] = '8';
	Label7->Caption = szOptionsForm[1];
	szOptionsForm[1][len-1] = '9';
	Label8->Caption = szOptionsForm[1];

	LabelLang->Caption = szOptionsForm[2];
	Cancel->Caption = szOptionsForm[3];
	Ok->Caption = szOptionsForm[4];
	ChDisableDMO->Caption = szOptionsForm[7];
	ChDisableDMO->Hint = szOptionsForm[8];
	ChAssocFiles->Caption = szOptionsForm[9];
	ChAssocFiles->Hint = szOptionsForm[10];
	ChAssocDir->Caption = szOptionsForm[11];
	ChAssocDir->Hint = szOptionsForm[12];
	ChExpCol->Caption = szOptionsForm[15];
	ChExpCol->Hint = szOptionsForm[16];

	Col2->Clear ();
	Col3->Clear ();
	Col4->Clear ();
	Col5->Clear ();
	Col6->Clear ();
	Col7->Clear ();
	Col8->Clear ();
	Col9->Clear ();
	for (int i=1 ; i<MAXCOL ; i++)
	{
		p = col[i].szColName;
		if (p[1] == '.')
			wsprintf (szBuf, "%s %s", *p=='V' ? szOtherString[13] :
						        	    *p=='A' ? szOtherString[14] :
						            	szOtherString[15], p+3-((i>=A1COI) && (i<=A2SIZ)));
        else	strcpy (szBuf, p);
		Col2->Items->Add (szBuf);
		Col3->Items->Add (szBuf);
		Col4->Items->Add (szBuf);
		Col5->Items->Add (szBuf);
		Col6->Items->Add (szBuf);
		Col7->Items->Add (szBuf);
		Col8->Items->Add (szBuf);
		Col9->Items->Add (szBuf);
	}
	InitCombo();
}

// Initialize the combobox

void __fastcall TOptionsForm::InitCombo()
{
	bButtonClose = false;

	Col2->ItemIndex = MainForm->colId[1]==-1 ? -1 : MainForm->colId[1]-1;
	Col3->ItemIndex = MainForm->colId[2]==-1 ? -1 : MainForm->colId[2]-1;
	Col4->ItemIndex = MainForm->colId[3]==-1 ? -1 : MainForm->colId[3]-1;
	Col5->ItemIndex = MainForm->colId[4]==-1 ? -1 : MainForm->colId[4]-1;
	Col6->ItemIndex = MainForm->colId[5]==-1 ? -1 : MainForm->colId[5]-1;
	Col7->ItemIndex = MainForm->colId[6]==-1 ? -1 : MainForm->colId[6]-1;
	Col8->ItemIndex = MainForm->colId[7]==-1 ? -1 : MainForm->colId[7]-1;
	Col9->ItemIndex = MainForm->colId[8]==-1 ? -1 : MainForm->colId[8]-1;
}

//---------------------------------------------------------------------------

void __fastcall TOptionsForm::ChSilentClick(TObject *Sender)
{
//	bOptions[OPT_Silent] = ChSilent->Checked;
}
void __fastcall TOptionsForm::ChDisableDMOClick(TObject *Sender)
{
	bOptions[OPT_DisableDMO] = ChDisableDMO->Checked;
}
void __fastcall TOptionsForm::ChAssocFilesClick(TObject *Sender)
{
    OptionsForm->UpdateAssoc(0, ChAssocFiles->Checked);
}
void __fastcall TOptionsForm::ChAssocDirClick(TObject *Sender)
{
    OptionsForm->UpdateAssoc(1, ChAssocDir->Checked);
}
void __fastcall TOptionsForm::ChExpColClick(TObject *Sender)
{
	bOptions[OPT_ExpCol] = ChExpCol->Checked;
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::ComboLangChange(TObject *Sender)
{
	strcpy (MainForm->szLang, ComboLang->Text.c_str());

	// Cancelling association with old language
	if (ChAssocFiles->Checked)	UpdateAssoc(0, false);
	if (ChAssocDir->Checked)	UpdateAssoc(1, false);

	MainForm->InitText ();
	MainForm->InitColumns (true);
   	SetLang();

	// Setting back association with new langage
	if (ChAssocFiles->Checked)	UpdateAssoc(0, true);
	if (ChAssocDir->Checked)	UpdateAssoc(1, true);
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::CancelClick(TObject *Sender)
{
	ComboLang->Text = szInitLang;
	ComboLangChange(Sender);
	bButtonClose = true;
    Close();
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::OkClick(TObject *Sender)
{
//	strcpy (MainForm->szLang, ComboLang->Text.c_str());

	MainForm->colId[1] = (Col2->ItemIndex >= 0) ? Col2->ItemIndex+1 : -1;
	MainForm->colId[2] = (Col3->ItemIndex >= 0) ? Col3->ItemIndex+1 : -1;
	MainForm->colId[3] = (Col4->ItemIndex >= 0) ? Col4->ItemIndex+1 : -1;
	MainForm->colId[4] = (Col5->ItemIndex >= 0) ? Col5->ItemIndex+1 : -1;
	MainForm->colId[5] = (Col6->ItemIndex >= 0) ? Col6->ItemIndex+1 : -1;
	MainForm->colId[6] = (Col7->ItemIndex >= 0) ? Col7->ItemIndex+1 : -1;
	MainForm->colId[7] = (Col8->ItemIndex >= 0) ? Col8->ItemIndex+1 : -1;
	MainForm->colId[8] = (Col9->ItemIndex >= 0) ? Col9->ItemIndex+1 : -1;
	MainForm->InitColumns (false);		// Update colums in MainWindow

	bButtonClose = true;
    Close();
}

//---------------------------------------------------------------------------
// Update association of AVIcodec with files & directories
// mode: 0=files, 1=dir
// way: true=set, false=unset

#define NBASSOC	12
#define MAXTYPELEN	20

void __fastcall TOptionsForm::UpdateAssoc(int mode, bool way)
{
	HKEY	hkey;
	int 	rc = 0;
	char	szKey[255], szSubKey[255], szValue[255], type[MAXTYPELEN+1];
    char	*ext[NBASSOC] = { ".ASF", ".ASX", ".AVI", ".DIVX", ".M1V", ".M2V", ".MPEG", ".MPG", ".OGG", ".OGM", ".RM", ".RMVB"};
	DWORD	dwDisposition, dwSize=MAXTYPELEN;

	wsprintf(szValue, "\"%s\\avicodec.exe\" \"%%1\"", MainForm->szInstallDir);
	if (!mode)				// File settings
    {
		bOptions[OPT_AssocFiles] = way;
		for (int i=0 ; i<NBASSOC ; i++)
        {
			rc = RegOpenKey(HKEY_CLASSES_ROOT, ext[i], &hkey);
			if (rc != ERROR_SUCCESS)	// Extension not defined on this computer
            	continue;
			rc = RegQueryValueEx(hkey, NULL, NULL, NULL, type, &dwSize);
			rc = RegCloseKey(hkey);

			wsprintf(szKey, "%s\\shell\\%s", type, szOptionsForm[13]);
			strcpy(szSubKey, szKey);
			strcat(szSubKey, "\\command");
			if (way==true)
        	{
		    	rc = RegCreateKeyEx(HKEY_CLASSES_ROOT, szSubKey, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, &dwDisposition);
				if (rc == ERROR_SUCCESS)
		    	{
					rc = RegSetValueEx(hkey, "", NULL, REG_SZ, szValue, lstrlen(szValue)+1);
					RegCloseKey(hkey);
				}
    	    }
        	else
            {
                rc = RegDeleteKey(HKEY_CLASSES_ROOT, szSubKey);
                rc = RegDeleteKey(HKEY_CLASSES_ROOT, szKey);
            }
        }
    }
    else if (mode==1)			// Dir settings
	{
		bOptions[OPT_AssocDir] = way;
	 	wsprintf(szKey, "Folder\\shell\\%s", szOptionsForm[14]);
		strcpy(szSubKey, szKey);
		strcat(szSubKey, "\\command");
	 	if (way==true)
       	{
	     	rc = RegCreateKeyEx(HKEY_CLASSES_ROOT, szSubKey, 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkey, &dwDisposition);
	 		if (rc == ERROR_SUCCESS)
	     	{
	 			rc = RegSetValueEx(hkey, "", NULL, REG_SZ, szValue, lstrlen(szValue)+1);
	 			RegCloseKey(hkey);
	 		}
        }
       	else
        {
           rc = RegDeleteKey(HKEY_CLASSES_ROOT, szSubKey);
           rc = RegDeleteKey(HKEY_CLASSES_ROOT, szKey);
		}
	}
}

// When closing, verify if from Cancel button or system menu

void __fastcall TOptionsForm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	if (!bButtonClose)   // Close from system menu of the DialogBox -> Cancel
        CancelClick(Sender);
}
//---------------------------------------------------------------------------

